//=============================================================================
// GallardoCar.
//
// Base model: model by (Tonny, Slightly Mad Studios).
//
// Official page of mod:
// http://www.set-games.ru/index/ProjectMarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2012.
//=============================================================================

class GallardoCar extends NKVCarNew;

defaultproperties
{
	 Tag="Lamborghini Gallardo"
	 TorqueCurve=(Points=((InVal=0.0,OutVal=100.0),(InVal=800000.0,OutVal=300.0),(InVal=1500000.0))

	 SlipVolume=20.0
	 WheelRadius=38.0
	 ActionAngularDamp=0.0
	 RestAngularDamp=0.7
	 RestFriction=0.1

     EngStartUpSound=None
     EngStopSound=None
     //EngStartUpSound=Sound'MaricaSounds.ut_engine_start_02'
     //EngStopSound=Sound'MaricaSounds.ut_engine_stop_02'
	 ImpactSoundsMin(0)=Sound'MaricaSounds.ut_impact_03'
	 ImpactSoundsMed(0)=Sound'MaricaSounds.ut_impact_01'
	 ImpactSoundsMed(1)=Sound'MaricaSounds.ut_impact_02'
	 ImpactSoundsMax(0)=Sound'MaricaSounds.ut_impact_04'
	 ImpactSoundsMax(1)=Sound'MaricaSounds.ut_impact_05'
	 ImpactSoundsMax(2)=Sound'MaricaSounds.ut_impact_06'
	 ImpactSoundsMax(3)=Sound'MaricaSounds.ut_impact_07'

	 ShadowLightDistance=1200
	 ShadowMaxTraceDistance=300

	 CameraDist=14.5
     Description="Lamborghini Gallardo. || Model by (Tonny, Slightly Mad Studios)."
	 DestroyBones(0)="FrontGlass"
	 DestroyBones(1)="Hood"
	 DestroyBones(2)="Trunk"
	 DestroyBones(3)="LampGlass"
	 DestroyBones(4)="LeftDoor"
	 DestroyBones(5)="RightDoor"
	 DestroyBones(6)="SteerWheel"
	 SteerWheelBone="SteerWheel"
	 bAllowBrokenWheels=True
	 bSpawnBrokenDetail=True

	 bFixedFPCamera=False
	 FrontLightMaterial=Texture'GenFX.LensFlar.6'
	 RearLightMaterial=Texture'GenFX.LensFlar.softlens2'
	 RearLightStopScale=0.200000
	 RearLightScale=0.100000
	 FrontLightScale=0.200000
     FrontLightClass=Class'NVFrontCarLight'
     RearLightClass=Class'NVRearCarLight'

     ExhaustClass=Class'CarExhaust'

	 DecoSystem=DS_Bones
	 ExhaustBones(0)="Exhaust00"
	 ExhaustBones(1)="Exhaust01"

	 FrontLightBones(0)="FrontLight00"
	 FrontLightBones(1)="FrontLight01"

	 RearLightBones(0)="RearLight00"
	 RearLightBones(1)="RearLight01"

	 bUpdateSusp=True
	 RSuspHighLimit=8.0
	 RSuspLowLimit=-20.0
     ExitPos=(Y=-140.0,Z=15.0)
     ExitPosPassenger=(Y=140.0,Z=15.0)
     EnterPos=(Y=145.0,Z=-5.0)
	 WheelFrontRight="RightFrontTIRE"
	 WheelFrontLeft="LeftFrontTIRE"
	 WheelRearRight="RightRearTIRE"
	 WheelRearLeft="LeftRearTIRE"
	 StrutFrontRight=""
	 StrutFrontLeft=""
	 StrutRearRight=""
	 StrutRearLeft=""
	 IntCollisionSize=(X=1,Y=1,Z=1)
	 IntCollisionModel=StaticMesh'GallardoCollision.GallardoIntColl'
	 IntCollisionClass=Class'IntCollisionActor'

	 LightProjectorClass=class'NVLightProjector'
	 ProjLightPos=(X=180.0,Y=0.0,Z=20.0)
	 ProjectedLightRot=(Pitch=-100)
	 ProjLightMaterial=Texture'MaricaTextures.Effects.LightProj_01'
	 ProjLightFOV=40
	 ProjLightScale=0.400000

	 bCarIsFTWD=False
     bCarIsRTWD=True
     MaxSpeedAccel=32.0
	 VehicleMaxSpeed=785325.0
     MaxSteerAngle=3500.0
     ChassisMass=2.7500000

	 bCanSeeDriver=True
	 DriverPos=(X=-28.600000,Y=-36.0,Z=-28.700000)
	 FPDriverViewPos=(X=-28.0,Y=-39.0,Z=28.0)
	 FPPassengerViewPos=(X=-28.0,Y=39.0,Z=28.0)
	 PassengerPos=(X=-28.600000,Y=36.0,Z=-28.700000)

	 RadiatorPos=(X=-170.0,Y=0.0,Z=25.0)
     VehicleFireClass=Class'VehicleFireEmitter'

	 BrokenSkins(0)=Texture'GallardoTex.gollardo_exp2'
	 BrokenSkins(2)=Texture'GallardoTex.gollardo_exp'
	 BrokenSkins(3)=Texture'GallardoTex.gollardo_exp2'
	 BrokenSkins(5)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(7)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(8)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(9)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(10)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(12)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(13)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(15)=Texture'GallardoTex.gollardo_exp'
	 BrokenSkins(16)=Texture'GallardoTex.gollardo_exp2'
	 BrokenSkins(18)=Texture'GallardoTex.gollardo_exp2'
	 BrokenSkins(20)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(21)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(22)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(23)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(24)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(25)=Shader'GallardoTex.common_black_shad'
	 BrokenSkins(27)=Texture'GallardoTex.gollardo_exp2'
	 BrokenSkins(29)=Texture'GallardoTex.gollardo_exp2'
	 BrokenSkins(30)=Texture'GallardoTex.gollardo_exp2'

	 bDamagableWheels=True
	 WheelsHealth=50
	 WheelsMaxHealth=100
	 UnloadWheelHeight=0.013200
	 bSparkWheels=True
     EngTireClass=Class'GallardoTire'
     SteerTireClass=Class'GallardoTire'
     WheelSteerAlong=106.0
     WheelSteerAcross=90.0
     WheelEngAlong=-165.0
     WheelEngAcross=90.0
     WheelVert=-41.0
     SuspStiffness=200.0
     SuspDamping=5.0
     SuspHighLimit=0.400000
     SuspLowLimit=-0.400000
     //TireRollFriction=1.500000
     //TireLateralFriction=1.250000

	 EnginePitch=15.0
	 EngineVolume=60.0
     EngineSound=Sound'MaricaSounds.UnWheel_idle10'
     ImpactSounds(0)=Sound'MaricaSounds.ut_impact_01'
     ImpactSounds(1)=Sound'MaricaSounds.ut_impact_02'

     StaticMesh=StaticMesh'GallardoCollision.GallardoKColl'
	 Mesh=SkeletalMesh'GallardoModel.Gallardo'

	 bRandomSkin=True
	 SkinIndex=2
	 Skins(2)=Shader'GallardoTex.Skin_01_shad'
	 OtherSkins(0)=Shader'GallardoTex.Skin_01_shad'
	 OtherSkins(1)=Shader'GallardoTex.Skin_02_shad'
	 OtherSkins(2)=Shader'GallardoTex.Skin_03_shad'
	 OtherSkins(3)=Shader'GallardoTex.Skin_04_shad'
	 OtherSkins(4)=Shader'GallardoTex.Skin_05_shad'

     Begin Object Class=KarmaParamsRBFull Name=GallardoPhysics
         //KInertiaTensor(0)=20.0
         //KInertiaTensor(3)=30.0
         //KInertiaTensor(5)=58.0
         KInertiaTensor(0)=4.0
         KInertiaTensor(3)=25.0
         KInertiaTensor(5)=45.0
		 //KCOMOffset=(X=-0.3,Z=-1.0)
         KCOMOffset=(X=-0.3,Z=-2.0)
		 KLinearDamping=0.050000
         KAngularDamping=0.700000
         KStartEnabled=True
         bKNonSphericalInertia=True
         KFriction=0.200000
         KImpactThreshold=250.0
         Name="GallardoPhysics"
     End Object
     KParams=KarmaParamsRBFull'GallardoPhysics'
}
