//=============================================================================
// DragonSpitFireCollision.uc
// Author: Nick Pilshikov "Evil"
// Email: Nick_Pv@mail.ru / EvilTheDark@gmail.com
// Site: Set-Games.ru / Revival-Games.ru
// Revival Games Studios.
// 2014.
//=============================================================================

class DragonSpitFireCollision extends Actor;

function Touch(Actor Other)
{
	local int newDamage;

	if( Other == None 
		|| !(Other.IsA('Pawn') 
			|| Other.IsA('NKVehicleTire') 
			|| Other.IsA('Projectile') 
			|| Other.IsA('Prop'))
		|| Pawn(Owner) == None 
		|| Owner == Other )
		return;

	newDamage = (8000/VSize(Other.Location-Location));

	Other.TakeDamage(newDamage, Pawn(Owner), Other.Location, (Other.Location-Location), class'SmashDamage');
	if( P2MoCapPawn(Other) != None && !Other.IsA('BlackDragon') )
		P2MoCapPawn(Other).SetOnFire(FPSPawn(Owner), true);
	else if( AnimalPawn(Other) != None )
		AnimalPawn(Other).SetOnFire(FPSPawn(Owner), true);
	else if( NKVehicleTire(Other) != None )
		NKVehicleTire(Other).BurnTire();
	//Pawn(Owner).ClientMessage(Other);
}

function Bump(Actor Other)
{
	Touch(Other);
}

function Timer()
{
	SetCollision(false, false, false);
}

defaultproperties
{
	 bCollideActors=false
	 bBlockActors=false
	 DrawType=DT_StaticMesh
	 StaticMesh=StaticMesh'MaricaDragonCollision.Dragon_SpitFire_collision'
	 bUnlit=true
	 bHidden=true
     bProjTarget=false
	 bUseCylinderCollision=false
     bCollideWorld=false
     bBlockPlayers=false
	 CollisionRadius=400.0
	 CollisionHeight=100.0
}
