//=============================================================================
// DragonsRagdollController.uc
// Author: Nick Pilshikov "Evil"
// Revival Games Studios.
// 2014.
//=============================================================================

class DragonsRagdollController extends Actor;

simulated function UnhookOldDragonsCorpses()
{
	local int i;
	local BlackDragon testCorpse;
	local array<BlackDragon> oldCorpses;

	foreach AllActors(class'BlackDragon', testCorpse)
	{
		if( testCorpse != None && testCorpse.Health <= 0 )
		{
			if( oldCorpses.Length == 0 )
				oldCorpses[oldCorpses.Length] = testCorpse;
			else if( testCorpse.Physics == PHYS_KarmaRagdoll 
				&& testCorpse.RagDollStartTime > oldCorpses[oldCorpses.Length].RagDollStartTime )
			{
				oldCorpses.Insert(oldCorpses.Length, 1.0);
				oldCorpses[oldCorpses.Length] = testCorpse;
			}
		}
	}
	if( oldCorpses.Length != 0 )
	{
		for( i = 0 ; i < oldCorpses.Length ; i++ )
		{
			if( oldCorpses[i] != None && oldCorpses[i].Physics == PHYS_KarmaRagdoll )
				oldCorpses[i].UnhookRagdoll();
		}
	}
}

defaultproperties
{
	 bHidden=true
	 bCollideActors=false
}
