class DragonsShadowProjector extends NVShadowProjector;

function UpdateShadow()
{
	local vector ShadowLocation;

	if( ShadowTexture == None )
	{
		InitShadow();
		return;
	}

	DetachProjector(true);
	SetCollision(false,false,false);

	if(ShadowActor != None && !ShadowActor.bHidden && ShadowActor.DrawType != DT_None)
	{
		if( ShadowActor.IsA('BlackDragon') )
			ShadowLocation = ShadowActor.GetBoneCoords('').Origin;
		else ShadowLocation = ShadowActor.Location + ((ShadowZ*vect(0,0,1)) >> ShadowActor.Rotation);

		SetLocation(ShadowLocation);
		SetRotation(Rotator(Normal(-LightDirection)));

		ShadowTexture.bBlobShadow = bBlobShadow;
		ShadowTexture.ShadowActor = ShadowActor;
		ShadowTexture.LightDirection = Normal(LightDirection);
		ShadowTexture.LightDistance = LightDistance;
		ShadowTexture.LightFOV = FOV;
		ShadowTexture.Dirty = true;

		AttachProjector();
		SetCollision(true,false,false);
	}
}

simulated function Tick(float DeltaTime)
{
	if( ShadowActor == None 
		|| !bUpdateShadow
		|| IsRenderingBan() ) 
		return;

	if(MyBase != None)
	{
		if(MyBase.mySpeed > 1.0 || bAcceptRender)
		{
			UpdateShadow();
			//log('Shadow is going to update for nkactor '$ActorSpeed);
		}
	}
	else if(MyCar != None)
	{
		if(!bInstantUpdate)
		{
			if(VSize(MyCar.Velocity) > 1.0)
				bAcceptRender = True;
			else
				bAcceptRender = False;
		}
		else bAcceptRender = True;
		if(MyCar.mySpeed > 1.0 || bSteerUpdate || bAcceptRender)
		{
			UpdateShadow();
			//log('Shadow is going to update for nkvehicle '$ActorSpeed);
		}
		if(MyCar.Steering != 0)
		{
			bSteerUpdate = True;
			SetTimer(1.0,false);
		}
	}
	else if(MyVeh != None)
	{
		if(MyVeh.mySpeed > 1.0 || bAcceptRender)
		{
			UpdateShadow();
			//log('Shadow is going to update for npvehicle '$ActorSpeed);
		}
	}
	else
	{
		if (Role == ROLE_Authority)
			if(ShadowActor != None)
				ActorSpeed = VSize(ShadowActor.Velocity);
		if(ActorSpeed > 1.0 || bAcceptRender)
		{
			UpdateShadow();
			//log('Shadow is going to update '$ActorSpeed);
		}
	}
	if( Level.TimeSeconds > UpdateAgain + 1 )
	{
		UpdateShadow();
		UpdateAgain = Level.TimeSeconds;
	}
}

defaultproperties
{
}
