//=============================================================================
// QuadBike.
//
// Base model: model by 2 Dawn Studios
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2014.
//=============================================================================

class QuadBike extends NKVCarNew;

defaultproperties
{
	 bLittleVehicle=true
	 AIChasingDist=100.0
	 bNormalHUDView=true
	 bAllowWeaponsInside=true
	 bDriverTakesDamage=true
	 Tag="Quad Bike"
	 ShadowZ=0.0
	 ExhaustBones(0)="Exhaust00"

	 TorqueCurve=(Points=((InVal=0.0,OutVal=50.0),(InVal=550000.0,OutVal=100.0),(InVal=800000.0))

     DrivingAnimStatus="EvilBikeDriver"
     SittingAnimStatus="EvilBikeDriver"

	 WheelRadius=43.0
	 ActionAngularDamp=0.0
	 RestAngularDamp=0.6

     EngStartUpSound=None
     EngStopSound=None
     //EngStartUpSound=Sound'MaricaSounds.ut_engine_start_02'
     //EngStopSound=Sound'MaricaSounds.ut_engine_stop_02'
	 ImpactSoundsMin(0)=Sound'MaricaSounds.ut_impact_03'
	 ImpactSoundsMed(0)=Sound'MaricaSounds.ut_impact_01'
	 ImpactSoundsMed(1)=Sound'MaricaSounds.ut_impact_02'
	 ImpactSoundsMax(0)=Sound'MaricaSounds.ut_impact_04'
	 ImpactSoundsMax(1)=Sound'MaricaSounds.ut_impact_05'
	 ImpactSoundsMax(2)=Sound'MaricaSounds.ut_impact_06'
	 ImpactSoundsMax(3)=Sound'MaricaSounds.ut_impact_07'

	 ShadowLightDistance=1200
	 ShadowMaxTraceDistance=230

	 CameraDist=10.0
	 bFixedFPCamera=False
	 bAllowPassenger=False
	 Description="Trike bike from Ravaged. || Model by 2 Dawn Studios."
	 DestroyBones(0)="Attachment"

	 DecoSystem=DS_Bones

	 FrontLightBones(0)="FrontLight00"

	 RSuspHighLimit=24.000000
	 RSuspLowLimit=-24.000000
     ExitPos=(Y=-140.000000,Z=15.000000)
     ExitPosPassenger=(Y=140.000000,Z=15.000000)
     EnterPos=(Y=90.000000,Z=-5.000000)
	 WheelFrontRight="RightFrontTIRE"
	 WheelFrontLeft="LeftFrontTIRE"
	 WheelRearRight="RightRearTIRE"
	 WheelRearLeft="LeftRearTIRE"
     StrutFrontRight="RightFrontSTRUT"
     StrutFrontLeft="LeftFrontSTRUT"
     StrutRearRight="RightRearSTRUT"
     StrutRearLeft="LeftRearSTRUT"
	 IntCollisionSize=(X=1,Y=1,Z=1)
	 IntCollisionModel=StaticMesh'MaricaQuadCollision.quad_IntColl'
	 IntCollisionClass=Class'IntCollisionActor'
     bCarIsRTWD=True
	 bCarIsFTWD=False
	 LightProjectorClass=class'NVLightProjector'
	 ProjLightPos=(X=120.000000,Y=0.000000,Z=-17.000000)
	 ProjLightMaterial=Texture'MaricaTextures.Effects.LightProj_01'
	 ProjLightFOV=40
	 ProjLightScale=0.400000
	 ProjectedLightRot=(Pitch=-100)
     FrontLightClass=Class'NVFrontCarLight'
     RearLightClass=Class'NVRearCarLight'
     bSpawnBrokenDetail=True
     bAllowBrokenWheels=True
     MaxSpeedAccel=26.000000
	 bCanSeeDriver=True
	 VehicleMaxSpeed=525350.000000
     MaxSteerAngle=3500.000000
	 //SteerSpeed=31500.000000
	 SteerSpeed=50000
     ChassisMass=3.000000
	 RadiatorPos=(X=5.000000,Y=0.000000,Z=-17.000000)
	 DriverPos=(X=-38.000000,Y=-2.000000,Z=28.000000)
	 FPDriverViewPos=(X=-15.000000,Y=0.000000,Z=30.000000)
	 FPPassengerViewPos=(X=-15.000000,Y=0.000000,Z=30.000000)
	 PassengerPos=(X=-50.000000,Y=-2.000000,Z=28.000000)
     ExhaustClass=Class'CarExhaust'
     VehicleFireClass=Class'VehicleFireEmitter'
	 bDamagableWheels=True
	 WheelsHealth=150
	 WheelsMaxHealth=200
	 UnloadWheelHeight=0.013200
	 bSparkWheels=True
     EngTireClass=Class'QuadBikeTire'
     SteerTireClass=Class'QuadBikeTire'
     WheelSteerAlong=55.0
     WheelSteerAcross=54.0
     WheelEngAlong=-58.5
     WheelEngAcross=54.0
     WheelVert=-28.0
	 SuspDamping=5.0
	 SuspStiffness=160.0
     SuspHighLimit=0.500000
     SuspLowLimit=-0.500000
     TireRollFriction=1.500000
     TireLateralFriction=2.000000
	 TireRollSlip=0.060000
	 TireLateralSlip=0.040000
	 TireSlipRate=0.007000
	 EngineVolume=200
	 EnginePitch=32
     EngineSound=Sound'MaricaSounds.BikeEngineSound01'
	 SlipVolume=15.0

     StaticMesh=StaticMesh'MaricaQuadCollision.quad_KColl'
	 Mesh=SkeletalMesh'MaricaQuadModels.QUAD_model_new'
	 DrawScale=1.0

	 bRandomSkin=false
	 SkinIndex=0
	 Skins(0)=Texture'MaricaQuadTex.quadskin'
	 OtherSkins(0)=Texture'MaricaQuadTex.quadskin'

	 SteerWheelBone="SteerWheel"

	 BrokenSkins(0)=Texture'MaricaQuadTex.quadskin_exp'

     Begin Object Class=KarmaParamsRBFull Name=QuadBikePhysics
         KInertiaTensor(0)=2.0
         KInertiaTensor(3)=4.0
         KInertiaTensor(5)=8.0
         KCOMOffset=(X=0.0,Z=-1.0)
		 KLinearDamping=0.050000
         KAngularDamping=0.600000
         KStartEnabled=True
         bKNonSphericalInertia=True
         KFriction=0.200000
         KImpactThreshold=250.000000
         Name="QuadBikePhysics"
     End Object
     KParams=KarmaParamsRBFull'QuadBikePhysics'
}