//=============================================================================
// SanchezBike.uc
// Author: Nick a.k.a Evil T-ModZ
// 2014.
//=============================================================================

class SanchezBike extends NKVCarNew;

var() Name FrontStrutBone;
var() Name FrontSuspBone;
var() Name FrontWheelBone;

var() Name RearStrutBone;
var() Name RearWheelBone;

simulated function MonitorBehindView(PlayerController PC, bool bDriver)
{
	local Actor myPawnActor, ViewPoint;
	local DriverBase PawnBase;
	local Pawn myPawn;
	if(PC == None)
		return;

	if(bDriver)
	{
		ViewPoint = FPDriverViewPoint;
		PawnBase = DriverBase;
		myPawnActor = myDriver;
		myPawn = Driver;
	}
	else
	{
		ViewPoint = FPPassengerViewPoint;
		PawnBase = PassengerBase;
		myPawnActor = myPassenger;
		myPawn = Passenger;
	}

	if(!bFixedFPCamera)
		ViewPoint.SetRotation(PC.Rotation);

	//if( SteerWheelBone != '')
	//	RotateSteeringWheel(PC.bBehindView);

	if(bAllowChangeView)
	{
		if( bNormalHUDView )
		{
			if( !PC.bBehindView )
				myPawnActor.bHidden = true;
			else myPawnActor.bHidden = false;
		}

		if(!PC.bBehindView)// && !ViewChanged)
		{
			PC.FixFOV();
			bHideDriverActor = true;
			if( myPawnActor != None && !bNormalHUDView )
				myPawnActor.bHidden = bHideDriverActor;
			//if( !bNormalHUDView )
				//PawnBase.SetHardAttach(true);
				PawnBase.SetFixedPosition(true);
			if(bFreeCamera)
				myPawn.SetBase(PawnBase);
			if( !bNormalHUDView )
				PC.ClientSetViewTarget(ViewPoint);
			else PC.ClientSetViewTarget(myPawn);
			PC.bFreeCamera = false;
			//ViewChanged = true;
		}
		else if(PC.bBehindView)// && ViewChanged)
		{
			bHideDriverActor = false;
			if( myPawnActor != None && !bNormalHUDView )
				myPawnActor.bHidden = bHideDriverActor;
			//if( !bNormalHUDView )
				//PawnBase.SetHardAttach(false);
				PawnBase.SetFixedPosition(false);
			if(bFreeCamera)
				myPawn.SetBase(PawnBase);
			PC.ClientSetViewTarget(self);
			//ViewChanged = false;
		}
	}
	else if(!PC.bBehindView)
		PC.ClientSetBehindView(true);
}

simulated function ApplyVehicleData()
{
	local int i;
	local vector Dir;
	local rotator FWheelRot;

	if( bBeep )
		PlayingBeepSound();

	if( Level.NetMode == NM_DedicatedServer )
		return;

	if( SteerWheelBone != '')
	{
		if( DriverController != None )
			RotateSteeringWheel(DriverController.bBehindView);
		else if( bAIControlled )
			RotateSteeringWheel(true);
		else RotateSteeringWheel(false);
	}

	Dir = vector(Rotation);

	if( FrontWheelBone != '' )
	{
		//if( Driver != None )
		//	Driver.ClientMessage(Tire1RotT.Pitch);
		FWheelRot.Pitch = Tire1RotT.Pitch;
		SetBoneRotation(FrontWheelBone,FWheelRot,0,1);
		//SetBoneDirection(FrontWheelBone,Tire1RotT,Dir,1);
		//SetBoneDirection(FrontWheelBone,Tire1RotT,Tire1Susp,1);
	}

	if( RearWheelBone != '' )
		SetBoneDirection(RearWheelBone,Tire3RotT,vect(0,0,0),1);
		//SetBoneDirection(RearWheelBone,Tire3RotT,Tire3Susp,1);

	if( FrontSuspBone != '' )
		SetBoneLocation(FrontSuspBone, (Tire1Susp+Tire2Susp)*0.5, 1);
		//SetBoneRotation(FrontSuspBone,Strut3Roll,0,1);

	Strut3Roll.Roll = 0;
	Strut3Roll.Pitch = (Tire3Susp.Z+Tire4Susp.Z)*0.5 * 175;
	if( RearStrutBone != '' )
		SetBoneRotation(RearStrutBone,Strut3Roll,0,1);

	if(VehicleDestroyed() && !bBonesDestroyed)
	{
		for(i = 0; i < DestroyBones.Length; i++)
			SetVehicleBoneScale(DestroyBones[i],0);
		SetSkin();
		bBonesDestroyed = true;
	}
}

simulated function RotateSteeringWheel(bool bFixed)
{
	local rotator TempRotation;

	//if( !bFixed )
	//{
		if( SteerWheelRotator != None )
		{
			if( SteeringAngle > 0.1 )
			{
				SteerWheelRotator.DesiredRotation.Yaw = 5000;
				SteerWheelRotator.RotationRate.Yaw = 45000;
			}
			else if( SteeringAngle < -0.1 )
			{
				SteerWheelRotator.DesiredRotation.Yaw = -5000;
				SteerWheelRotator.RotationRate.Yaw = -45000;
			}
			else
			{
				if( Normalize(SteerWheelRotator.Rotation).Yaw > 0 )
					SteerWheelRotator.RotationRate.Yaw = -45000;
				else if( Normalize(SteerWheelRotator.Rotation).Yaw < 0 )
					SteerWheelRotator.RotationRate.Yaw = 45000;
				SteerWheelRotator.DesiredRotation.Yaw = 0;
			}

			TempRotation.Yaw = SteerWheelRotator.Rotation.Yaw;
			SetBoneRotation(SteerWheelBone,TempRotation,0,1);
			SetBoneRotation(FrontStrutBone,TempRotation,0,1);
		}
	/*}
	else
	{
		SetBoneRotation(SteerWheelBone,rot(0,0,0),0,1);
		SetBoneRotation(FrontStrutBone,rot(0,0,0),0,1);
	}*/
}

state BeforeBeStart
{
	simulated function Tick(float DeltaTime)
	{
		ContinuousUpdate();
	}

    function BeginState()
    {
		if(EngStartUpSound != None)
			PlaySound(EngStartUpSound, SLOT_Misc, EngineStartUpVolume);
    }

Begin:
	KSetStayUpright(true, true);
    Sleep(EngineStartTime);
	KSetStayUpright(false, false);
    VehicleHaveDriver();
	GotoState('VehicleDriving');
}

state VehicleDriving
{
	function DrivingSimulation(float DesiredSpeed)
	{
		local float ForwardSpeed , RotSteer , RotAng , Torque , tempSteering;
		local vector worldForward;

		worldForward = vect(1,0,0) >> Rotation;
		ForwardSpeed = Velocity Dot worldForward;
		WheelSpinSpeed = (EngTireRight.SpinSpeed + EngTireLeft.SpinSpeed)/2;

		if(Driver == None && !bAIControlled)
			return;

		if(DesiredSpeed > 1100)
			RotAng = 1.0;
		else RotAng = 1.5;

		if( ForwardSpeed < -1.0 )
		{
			EngTireRight.WheelJoint.KMaxSpeed = VehicleMaxSpeed * RearMoveAccel;
			EngTireLeft.WheelJoint.KMaxSpeed = VehicleMaxSpeed * RearMoveAccel;
			SteerTireRight.WheelJoint.KMaxSpeed = VehicleMaxSpeed * RearMoveAccel;
			SteerTireLeft.WheelJoint.KMaxSpeed = VehicleMaxSpeed * RearMoveAccel;
		}
		else
		{
			if( EngTireRight.WheelJoint.KMaxSpeed != VehicleMaxSpeed )
			{
				EngTireRight.WheelJoint.KMaxSpeed = VehicleMaxSpeed;
				EngTireLeft.WheelJoint.KMaxSpeed = VehicleMaxSpeed;
				SteerTireRight.WheelJoint.KMaxSpeed = VehicleMaxSpeed;
				SteerTireLeft.WheelJoint.KMaxSpeed = VehicleMaxSpeed;
			}
		}

		if( Throttle > 0 )
		{
			Torque = EngineSimulation(Throttle) * 0.5;
			EngineModel(ForwardSpeed, Torque);
		}
		else
		{
			Torque = EngineSimulation(-0.1) * 0.5;
			EngineModel(0, 0);
		}

		if(bCarIsRTWD)
		{
			EngTireRight.WheelJoint.KMotorTorque = Torque;
			EngTireLeft.WheelJoint.KMotorTorque = Torque;
			if( CrossTireClass != None )
			{
				CrossTireRight.WheelJoint.KMotorTorque = Torque;
				CrossTireLeft.WheelJoint.KMotorTorque = Torque;
			}
		}
		if(bCarIsFTWD)
		{
			SteerTireRight.WheelJoint.KMotorTorque = Torque;
			SteerTireLeft.WheelJoint.KMotorTorque = Torque;
			if( CrossTireClass != None )
			{
				CrossTireRight.WheelJoint.KMotorTorque = Torque;
				CrossTireLeft.WheelJoint.KMotorTorque = Torque;
			}
		}

		tempSteering = Steering;
		if( bAIControlled )
			tempSteering *= 0.2;
		if( DesiredSpeed > 120 && tempSteering > 0.1 )
		{
			SteerTireRight.WheelJoint.KSuspHighLimit = -0.15;
			SteerTireRight.WheelJoint.KSuspLowLimit = -0.25;
			SteerTireRight.WheelJoint.KUpdateConstraintParams();
			EngTireRight.WheelJoint.KSuspHighLimit = -0.15;
			EngTireRight.WheelJoint.KSuspLowLimit = -0.25;
			EngTireRight.WheelJoint.KUpdateConstraintParams();

			SteerTireLeft.WheelJoint.KSuspHighLimit = 0.15;
			SteerTireLeft.WheelJoint.KSuspLowLimit = 0.25;
			SteerTireLeft.WheelJoint.KUpdateConstraintParams();
			EngTireLeft.WheelJoint.KSuspHighLimit = 0.15;
			EngTireLeft.WheelJoint.KSuspLowLimit = 0.25;
			EngTireLeft.WheelJoint.KUpdateConstraintParams();
		}
		else if( DesiredSpeed > 120 && tempSteering < -0.1 )
		{
			SteerTireRight.WheelJoint.KSuspHighLimit = 0.15;
			SteerTireRight.WheelJoint.KSuspLowLimit = 0.25;
			SteerTireRight.WheelJoint.KUpdateConstraintParams();
			EngTireRight.WheelJoint.KSuspHighLimit = 0.15;
			EngTireRight.WheelJoint.KSuspLowLimit = 0.25;
			EngTireRight.WheelJoint.KUpdateConstraintParams();

			SteerTireLeft.WheelJoint.KSuspHighLimit = -0.15;
			SteerTireLeft.WheelJoint.KSuspLowLimit = -0.25;
			SteerTireLeft.WheelJoint.KUpdateConstraintParams();
			EngTireLeft.WheelJoint.KSuspHighLimit = -0.15;
			EngTireLeft.WheelJoint.KSuspLowLimit = -0.25;
			EngTireLeft.WheelJoint.KUpdateConstraintParams();
		}
		else
		{
			SteerTireRight.WheelJoint.KSuspHighLimit = SuspHighLimit;
			SteerTireRight.WheelJoint.KSuspLowLimit = SuspLowLimit;
			SteerTireRight.WheelJoint.KUpdateConstraintParams();
			EngTireRight.WheelJoint.KSuspHighLimit = SuspHighLimit;
			EngTireRight.WheelJoint.KSuspLowLimit = SuspLowLimit;
			EngTireRight.WheelJoint.KUpdateConstraintParams();

			SteerTireLeft.WheelJoint.KSuspHighLimit = SuspHighLimit;
			SteerTireLeft.WheelJoint.KSuspLowLimit = SuspLowLimit;
			SteerTireLeft.WheelJoint.KUpdateConstraintParams();
			EngTireLeft.WheelJoint.KSuspHighLimit = SuspHighLimit;
			EngTireLeft.WheelJoint.KSuspLowLimit = SuspLowLimit;
			EngTireLeft.WheelJoint.KUpdateConstraintParams();
		}
		RotSteer = Steering * MaxSteerAngle * RotAng;
		SteerTireRight.WheelJoint.KSteerAngle = RotSteer;
		SteerTireLeft.WheelJoint.KSteerAngle = RotSteer;

		if(Throttle > 0.01)
		{
			if(!bAIControlled)
			{
				if(ForwardSpeed < -StopThreshold && Gear != 1)
				{
					Gear = 0;
					OutputBrake = true;
					IsDriving = false;
				}
				else
				{
					Gear = 1;
					OutputBrake = false;
					IsDriving = true;
				}
			}

			if(bCarIsRTWD)
			{
				EngTireRight.WheelJoint.KWake();
				EngTireLeft.WheelJoint.KWake();
				EngTireRight.KWake();
				EngTireLeft.KWake();
				if( CrossTireClass != None )
				{
					CrossTireRight.WheelJoint.KWake();
					CrossTireLeft.WheelJoint.KWake();
					CrossTireRight.KWake();
					CrossTireLeft.KWake();
				}
			}
			if(bCarIsFTWD)
			{
				SteerTireRight.WheelJoint.KWake();
				SteerTireLeft.WheelJoint.KWake();
				SteerTireRight.KWake();
				SteerTireLeft.KWake();
				if( CrossTireClass != None )
				{
					CrossTireRight.WheelJoint.KWake();
					CrossTireLeft.WheelJoint.KWake();
					CrossTireRight.KWake();
					CrossTireLeft.KWake();
				}
			}
		}
		else if(Throttle < -0.01)
		{
			if(!bAIControlled)
			{
				if(ForwardSpeed < StopThreshold && IsDriving == false)
				{
					Gear = -1;
					OutputBrake = false;
					IsDriving = false;
				}
				else
				{
					Gear = 0;
					OutputBrake = true;
					IsDriving = true;
				}
			}

			if(bCarIsRTWD)
			{
				EngTireRight.WheelJoint.KWake();
				EngTireLeft.WheelJoint.KWake();
				EngTireRight.KWake();
				EngTireLeft.KWake();
				if( CrossTireClass != None )
				{
					CrossTireRight.WheelJoint.KWake();
					CrossTireLeft.WheelJoint.KWake();
					CrossTireRight.KWake();
					CrossTireLeft.KWake();
				}
			}
			if(bCarIsFTWD)
			{
				SteerTireRight.WheelJoint.KWake();
				SteerTireLeft.WheelJoint.KWake();
				SteerTireRight.KWake();
				SteerTireLeft.KWake();
				if( CrossTireClass != None )
				{
					CrossTireRight.WheelJoint.KWake();
					CrossTireLeft.WheelJoint.KWake();
					CrossTireRight.KWake();
					CrossTireLeft.KWake();
				}
			}
		}
		else
		{
			if(!bAIControlled)
			{
				if(Abs(ForwardSpeed) < StopThreshold)
				{
					Gear = 0;
					OutputBrake = true;
					IsDriving = false;
					OutputHandbrakeOn = false;
				}
				else
				{
					Gear = 0;
					OutputBrake = false;
					IsDriving = false;
				}
			}
		}

		if( DriverController != None && DriverController.bWantsToSkip > 0 )
		{
			Gear = 0;
			OutputBrake = true;
			IsDriving = true;
		}

		if((ForwardSpeed > HandbrakeThresh || OutputHandbrakeOn == true) 
				&& Abs(Steering) > 0.01 
				&& OutputBrake == true)
			OutputHandbrakeOn = true;
		else
			OutputHandbrakeOn = false;

		if(OutputBrake)
		{
			EngTireRight.WheelJoint.KBraking = MaxBrakeTorque;
			EngTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
			SteerTireRight.WheelJoint.KBraking = MaxBrakeTorque;
			SteerTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
		}
		else
		{
			EngTireRight.WheelJoint.KBraking = 0.0;
			EngTireLeft.WheelJoint.KBraking = 0.0;
			SteerTireRight.WheelJoint.KBraking = 0.0;
			SteerTireLeft.WheelJoint.KBraking = 0.0;
		}

		if(OutputHandbrakeOn == true)
		{
			SteerTireRight.LateralFriction = TireLateralFriction + (TireHandbrakeFriction/2);
			SteerTireRight.LateralSlip = TireLateralSlip + TireHandbrakeSlip;

			SteerTireLeft.LateralFriction = TireLateralFriction + (TireHandbrakeFriction/2);
			SteerTireLeft.LateralSlip = TireLateralSlip + TireHandbrakeSlip;

			EngTireRight.LateralFriction = TireLateralFriction + TireHandbrakeFriction;
			EngTireRight.LateralSlip = TireLateralSlip + TireHandbrakeSlip;

			EngTireLeft.LateralFriction = TireLateralFriction + TireHandbrakeFriction;
			EngTireLeft.LateralSlip = TireLateralSlip + TireHandbrakeSlip;
		}
		else
		{
			SteerTireRight.LateralFriction = TireLateralFriction;
			SteerTireRight.LateralSlip = TireLateralSlip;

			SteerTireLeft.LateralFriction = TireLateralFriction;
			SteerTireLeft.LateralSlip = TireLateralSlip;

			EngTireRight.LateralFriction = TireLateralFriction;
			EngTireRight.LateralSlip = TireLateralSlip;

			EngTireLeft.LateralFriction = TireLateralFriction;
			EngTireLeft.LateralSlip = TireLateralSlip;
		}

		KWake();
		UpdateRearLight();
	}
}

defaultproperties
{
	 bLittleVehicle=true
	 FrontStrutBone="FrontWheelStrut"
	 FrontSuspBone="FrontWheelSusp"
	 FrontWheelBone="FrontWheelTire"
	 RearStrutBone="RearWheelStrut"
	 RearWheelBone="RearWheelTire"

	 RearMoveAccel=0.6
	 EngineStartTime=0.1
	 AIChasingDist=100.0
	 bNormalHUDView=true
	 bAllowWeaponsInside=true
	 bDriverTakesDamage=true
	 Tag="Sanchez Bike"
	 ShadowZ=0.0
	 ExhaustBones(0)="Exhaust00"

	 TorqueCurve=(Points=((InVal=0.0,OutVal=60.0),(InVal=550000.0,OutVal=80.0),(InVal=800000.0))

     DrivingAnimStatus="EvilBikeDriver"
     SittingAnimStatus="EvilBikeDriver"

	 WheelRadius=43.0
	 ActionAngularDamp=0.0
	 RestAngularDamp=2.6

     EngStartUpSound=None
     EngStopSound=None
     //EngStartUpSound=Sound'MaricaSounds.ut_engine_start_02'
     //EngStopSound=Sound'MaricaSounds.ut_engine_stop_02'
	 ImpactSoundsMin(0)=Sound'MaricaSounds.ut_impact_03'
	 ImpactSoundsMed(0)=Sound'MaricaSounds.ut_impact_01'
	 ImpactSoundsMed(1)=Sound'MaricaSounds.ut_impact_02'
	 ImpactSoundsMax(0)=Sound'MaricaSounds.ut_impact_04'
	 ImpactSoundsMax(1)=Sound'MaricaSounds.ut_impact_05'
	 ImpactSoundsMax(2)=Sound'MaricaSounds.ut_impact_06'
	 ImpactSoundsMax(3)=Sound'MaricaSounds.ut_impact_07'

	 ShadowLightDistance=1200
	 ShadowMaxTraceDistance=230

	 CameraDist=10.0
	 bFixedFPCamera=False
	 bAllowPassenger=False
	 Description="Trike bike from Ravaged. || Model by 2 Dawn Studios."
	 DestroyBones(0)="Attachment"

	 DecoSystem=DS_Bones

	 FrontLightBones(0)="FrontLight00"

	 RSuspHighLimit=24.000000
	 RSuspLowLimit=-24.000000
     ExitPos=(Y=-140.000000,Z=15.000000)
     ExitPosPassenger=(Y=140.000000,Z=15.000000)
     EnterPos=(Y=80.000000,Z=-5.000000)
	 WheelFrontRight="RightFrontTIRE"
	 WheelFrontLeft="LeftFrontTIRE"
	 WheelRearRight="RightRearTIRE"
	 WheelRearLeft="LeftRearTIRE"

	 IntCollisionSize=(X=1,Y=1,Z=1)
	 IntCollisionModel=StaticMesh'MaricaSanchezCollision.sanchez_IntColl'
	 IntCollisionClass=Class'IntCollisionActor'
     bCarIsRTWD=true
	 bCarIsFTWD=true
	 LightProjectorClass=class'NVLightProjector'
	 ProjLightPos=(X=120.000000,Y=0.000000,Z=-17.000000)
	 ProjLightMaterial=Texture'MaricaTextures.Effects.LightProj_01'
	 ProjLightFOV=40
	 ProjLightScale=0.400000
	 ProjectedLightRot=(Pitch=-100)
     FrontLightClass=Class'NVFrontCarLight'
     RearLightClass=Class'NVRearCarLight'
     bSpawnBrokenDetail=True
     bAllowBrokenWheels=True
     MaxSpeedAccel=26.000000
	 bCanSeeDriver=True
	 VehicleMaxSpeed=925350.000000
     MaxSteerAngle=3500.000000
	 //SteerSpeed=31500.000000
     ChassisMass=2.000000
	 RadiatorPos=(X=5.000000,Y=0.000000,Z=-17.000000)
	 DriverPos=(X=-38.000000,Y=-2.000000,Z=28.000000)
	 FPDriverViewPos=(X=-15.000000,Y=0.000000,Z=30.000000)
	 FPPassengerViewPos=(X=-15.000000,Y=0.000000,Z=30.000000)
	 PassengerPos=(X=-50.000000,Y=-2.000000,Z=28.000000)
     ExhaustClass=Class'CarExhaust'
     VehicleFireClass=Class'VehicleFireEmitter'
	 bDamagableWheels=false
	 WheelsHealth=150
	 WheelsMaxHealth=200
	 UnloadWheelHeight=0.013200
	 bSparkWheels=True
     EngTireClass=Class'SanchezBikeTire'
     SteerTireClass=Class'SanchezBikeTire'
     WheelSteerAlong=55.0
     WheelSteerAcross=30.0
     WheelEngAlong=-70.0
     WheelEngAcross=30.0
     WheelVert=-22.5
	 SuspDamping=5.0
	 SuspStiffness=160.0
     //SuspHighLimit=0.500000
     //SuspLowLimit=-0.500000
     SuspHighLimit=0.2
     SuspLowLimit=-0.2
     TireRollFriction=1.500000
     TireLateralFriction=2.000000
	 TireRollSlip=0.060000
	 TireLateralSlip=0.040000
	 TireSlipRate=0.007000
	 EngineVolume=200
	 EnginePitch=32
     EngineSound=Sound'MaricaSounds.BikeEngineSound01'

     StaticMesh=StaticMesh'MaricaSanchezCollision.sanchez_KColl'
	 Mesh=SkeletalMesh'MaricaSanchezModels.Sanchez_Mesh'
	 DrawScale=1.0

	 bRandomSkin=false
	 SkinIndex=0
	 Skins(0)=Shader'MaricaSanchezTex.snz_sanchez_skin02'
	 OtherSkins(0)=Shader'MaricaSanchezTex.snz_sanchez_skin02'

	 SteerWheelBone="SteerWheel"

	 BrokenSkins(0)=Shader'MaricaSanchezTex.snz_sanchez_skin02'

     Begin Object Class=KarmaParamsRBFull Name=SanchezBikePhysics
         KInertiaTensor(0)=2.0
         KInertiaTensor(3)=4.0
         KInertiaTensor(5)=8.0
         KCOMOffset=(X=0.0,Z=-1.0)
		 KLinearDamping=0.050000
         KAngularDamping=0.600000
		 //bKStayUpright=true
		 //bKAllowRotate=true
         KStartEnabled=True
         bKNonSphericalInertia=True
         KFriction=0.200000
         KImpactThreshold=250.000000
         Name="SanchezBikePhysics"
     End Object
     KParams=KarmaParamsRBFull'SanchezBikePhysics'
}