//=============================================================================
// GmcC4500Car.
//
// Base model: model by SHAKE, wja, Lil Flip, Schaefft, MAGYAR.
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2014.
//=============================================================================

class GmcC4500Car extends NKVCarNew;

var bool bGatesOpened;
var TruckSoundIndicator TruckSoundIndicator;

var() Name GateRight, GateLeft;

var GmcC4500CarGatesTrigger GatesTrigger;
var MotionRotatorActor GatesRotator;

var() vector GatesEnterPos;

replication
{
	unreliable if( Role == ROLE_Authority )
		GatesRotator , bGatesOpened;
}

simulated function Destroyed()
{
	Super.Destroyed();

	if( GatesRotator != None )
		GatesRotator.Destroy();

	if( GatesTrigger != None )
		GatesTrigger.Destroy();

	if( TruckSoundIndicator != None )
		TruckSoundIndicator.Destroy();
}

simulated function PostBeginPlay()
{
	Super.PostBeginPlay();

	//if(Level.NetMode != NM_Client)
		GatesRotator = spawn(class'MotionRotatorActor');

	GatesTrigger = spawn(class'GmcC4500CarGatesTrigger',self, , Location + (GatesEnterPos >> Rotation));
	GatesTrigger.SetBase(self);
	GatesTrigger.SetCollision(true, false, false);

	if( TruckSoundIndicator == None )
		TruckSoundIndicator = spawn(class'TruckSoundIndicator',self,,Location,Rotation);
	if( TruckSoundIndicator != None )
	{
		TruckSoundIndicator.SetLocation(Location);
		TruckSoundIndicator.SetBase(self);
	}
}

simulated function ContinuousUpdate()
{
	Super.ContinuousUpdate();
	RotateGates();
	if( TruckSoundIndicator != None )
	{
		if( Driver != None )
		{
			if( Throttle < -0.1 && Gear == -1 )
				TruckSoundIndicator.SoundVolume = 150;
			else TruckSoundIndicator.SoundVolume = 0;
		}
		if( Driver == None || Health <= 0 )
			TruckSoundIndicator.SoundVolume = 0;
	}
}

simulated function RotateGates()
{
	local rotator TempRotation;

	if( GatesRotator != None && GateRight != '' && GateLeft != '' )
	{
		if( bGatesOpened )
		{
			GatesRotator.DesiredRotation.Yaw = 18000;
			GatesRotator.RotationRate.Yaw = 45000;
		}
		else
		{
			GatesRotator.DesiredRotation.Yaw = 0;
			GatesRotator.RotationRate.Yaw = -45000;
		}
		TempRotation.Yaw = GatesRotator.Rotation.Yaw;
		SetBoneRotation(GateRight,TempRotation,0,1);
		TempRotation.Yaw = -GatesRotator.Rotation.Yaw/2;
		SetBoneRotation(GateLeft,TempRotation,0,2);
	}	
}

simulated function OpenGates()
{
	bGatesOpened = !bGatesOpened;
}

defaultproperties
{
	 GateRight="RightRearDoor"
	 GateLeft="LeftRearDoor"
	 GatesEnterPos=(X=-300.0)
	 Tag="GMC C4500"
	 ShadowZ=50.0
	 TorqueCurve=(Points=((InVal=0.0,OutVal=45.0),(InVal=650000.0,OutVal=100.0),(InVal=900000.0))

	 RearMoveAccel=0.5
	 SlipVolume=10.0
	 EngineVolume=50.0
	 //SteerSpeed=31500.000000
	 MaxBrakeTorque=45
	 WheelRadius=37.0
	 ActionAngularDamp=0.0
	 RestAngularDamp=0.7

     EngStartUpSound=None
     EngStopSound=None
     //EngStartUpSound=Sound'MaricaSounds.ut_engine_start_01'
     //EngStopSound=Sound'MaricaSounds.ut_engine_stop_01'
	 ImpactSoundsMin(0)=Sound'MaricaSounds.ut_impact_03'
	 ImpactSoundsMed(0)=Sound'MaricaSounds.ut_impact_01'
	 ImpactSoundsMed(1)=Sound'MaricaSounds.ut_impact_02'
	 ImpactSoundsMax(0)=Sound'MaricaSounds.ut_impact_04'
	 ImpactSoundsMax(1)=Sound'MaricaSounds.ut_impact_05'
	 ImpactSoundsMax(2)=Sound'MaricaSounds.ut_impact_06'
	 ImpactSoundsMax(3)=Sound'MaricaSounds.ut_impact_07'

	 ShadowLightDistance=1200
	 ShadowMaxTraceDistance=300

	 CameraDist=16.0
	 CameraDistMin=11.0
	 Description="GMC C4500. || Model by SHAKE, wja, Lil Flip, Schaefft, MAGYAR."
     DestroyBones(0)="RightFrontDOOR"
     DestroyBones(1)="RightRearDOOR"
     DestroyBones(2)="LeftFrontDOOR"
     DestroyBones(3)="LeftRearDOOR"
     DestroyBones(4)="Windows"
     DestroyBones(5)="Attachment"
	 DestroyBones(6)="SteerWheel"
	 bAllowBrokenWheels=True
	 bSpawnBrokenDetail=True

	 bFixedFPCamera=False
	 FrontLightMaterial=Texture'GenFX.LensFlar.6'
	 RearLightMaterial=Texture'GenFX.LensFlar.softlens2'
	 RearLightStopScale=0.200000
	 RearLightScale=0.100000
	 FrontLightScale=0.200000
     FrontLightClass=Class'NVFrontCarLight'
     RearLightClass=Class'NVRearCarLight'
     FrontLightPos(0)=(X=216.000000,Y=50.000000,Z=-2.000000)
     FrontLightPos(1)=(X=216.000000,Y=-50.000000,Z=-2.000000)
     FrontLightPos(2)=(X=216.000000,Y=68.000000,Z=-2.000000)
     FrontLightPos(3)=(X=216.000000,Y=-68.000000,Z=-2.000000)
     FrontLightPos(4)=(X=216.000000,Y=28.500000,Z=-27.500000)
     FrontLightPos(5)=(X=216.000000,Y=-28.500000,Z=-27.500000)
     RearLightPos(0)=(X=-220.000000,Y=55.000000,Z=10.000000)
     RearLightPos(1)=(X=-220.000000,Y=-55.000000,Z=10.000000)

     ExhaustClass=Class'CarExhaust'
	 ExhaustPos(0)=(X=-88.000000,Y=86.000000,Z=-45.000000)
	 ExhaustPos(1)=(X=-88.000000,Y=-86.000000,Z=-45.000000)
	 ExhaustPos(2)=(X=-65.000000,Y=86.000000,Z=-45.000000)
	 ExhaustPos(3)=(X=-65.000000,Y=-86.000000,Z=-45.000000)

	 DecoSystem=DS_Bones
	 ExhaustBones(0)="Exhaust00"
	 SteerWheelBone="SteerWheel"

	 FrontLightBones(0)="FrontLight00"
	 FrontLightBones(1)="FrontLight01"

	 RearLightBones(0)="RearLight00"
	 RearLightBones(1)="RearLight01"

	 bUpdateSusp=True
	 RSuspHighLimit=17.000000
	 RSuspLowLimit=-17.000000
     ExitPos=(X=110.0,Y=-140.000000,Z=15.000000)
     ExitPosPassenger=(Y=140.000000,Z=15.000000)
     EnterPos=(X=110.0,Y=145.000000,Z=-5.000000)
	 WheelFrontRight="RightFrontTIRE"
	 WheelFrontLeft="LeftFrontTIRE"
	 WheelRearRight="RightRearTIRE"
	 WheelRearLeft="LeftRearTIRE"
	 StrutFrontRight=""
	 StrutFrontLeft=""
	 StrutRearRight=""
	 StrutRearLeft=""
	 IntCollisionSize=(X=1,Y=1,Z=1)
	 IntCollisionModel=StaticMesh'MaricaSilverDragonCollision.GMC_C4500_IntColl'
	 IntCollisionClass=Class'IntCollisionActor'

	 LightProjectorClass=class'NVLightProjector'
	 ProjLightPos=(X=180.000000,Y=0.000000,Z=20.000000)
	 ProjectedLightRot=(Pitch=-100)
	 ProjLightMaterial=Texture'MaricaTextures.Effects.LightProj_01'
	 ProjLightFOV=40
	 ProjLightScale=0.400000

	 bCarIsFTWD=False
     bCarIsRTWD=True
     MaxSpeedAccel=30.000000
	 VehicleMaxSpeed=455325.000000
     MaxSteerAngle=3500.000000
     ChassisMass=2.7500000

	 bCanSeeDriver=True
	 myDriverSize=0.85
	 DriverPos=(X=95.000000,Y=-38.000000,Z=18.000000)
	 FPDriverViewPos=(X=105.000000,Y=-39.000000,Z=75.000000)
	 FPPassengerViewPos=(X=105.000000,Y=39.000000,Z=75.000000)
	 PassengerPos=(X=95.000000,Y=38.000000,Z=18.000000)

	 RadiatorPos=(X=200.000000,Y=0.000000,Z=30.000000)
     VehicleFireClass=Class'VehicleFireEmitter'

	 BrokenSkins(0)=Shader'MaricaSilverDragonTex.GMC.gmc_skin01'

	 bDamagableWheels=True
	 WheelsHealth=50
	 WheelsMaxHealth=100
	 UnloadWheelHeight=0.013200
	 bSparkWheels=True
     EngTireClass=Class'GmcC4500CarTire'
     SteerTireClass=Class'GmcC4500CarTire'
     WheelSteerAlong=195.000000
     WheelSteerAcross=70.000000
     WheelEngAlong=-148.500000
     WheelEngAcross=70.000000
     WheelVert=-33.5
     SuspStiffness=200.000000
     SuspDamping=5.000000
     SuspHighLimit=0.400000
     SuspLowLimit=-0.400000
     TireLateralFriction=2.000000
	 TireRollSlip=0.060000
	 TireLateralSlip=0.040000
	 TireSlipRate=0.007000

	 EnginePitch=55.0
	 EngineSound=Sound'MaricaSounds.UnWheel_idle08'
     //EngineSound=Sound'MaricaSounds.UnWheel_idle10'
     ImpactSounds(0)=Sound'MaricaSounds.ut_impact_01'
     ImpactSounds(1)=Sound'MaricaSounds.ut_impact_02'

     StaticMesh=StaticMesh'MaricaSilverDragonCollision.GMC_C4500_KColl'
	 Mesh=SkeletalMesh'MaricaSilverDragonModels.GMC_C4500_Mesh'

	 bRandomSkin=false
	 SkinIndex=0
	 Skins(0)=Shader'MaricaSilverDragonTex.GMC.gmc_skin01'

     Begin Object Class=KarmaParamsRBFull Name=GMCTruckPhysics
         KInertiaTensor(0)=4.000000
         KInertiaTensor(3)=25.000000
         KInertiaTensor(5)=45.000000
         KCOMOffset=(X=-0.3,Z=-1.5)
		 KLinearDamping=0.050000
         KAngularDamping=0.700000
         KStartEnabled=True
         bKNonSphericalInertia=True
         KFriction=0.200000
         KImpactThreshold=250.000000
         Name="GMCTruckPhysics"
     End Object
     KParams=KarmaParamsRBFull'GMCTruckPhysics'
}