//=============================================================================
// GmcC4500CarGatesTrigger.
// Author: Evil T-ModZ (Nick)
// 2014.
//=============================================================================

class GmcC4500CarGatesTrigger extends ScriptedSequence
	notplaceable;

var float ReTriggerDelay;
var	float TriggerTime;

function Touch( Actor Other )
{
	local Pawn User;

	if( Instigator == None )
		Instigator = None;

	if(Other == None
		|| Other.Instigator == None
		|| Other.IsA('MpMonkey')
		|| Other.IsA('MpHeadcrab')
		|| Other.IsA('NPVehicle')
		|| Other.IsA('HelicopterVehicle')
		|| Other.IsA('KVehicle')
		|| Other.IsA('PostalMultiplayerChicken')
		|| Other.IsA('PostalMultiplayerAirCraftVehicle'))
			return;

	User = Pawn(Other);

	if(User == None)
		return;

	if(ReTriggerDelay > 0)
	{
		if ( Level.TimeSeconds - TriggerTime < ReTriggerDelay )
			return;
		TriggerTime = Level.TimeSeconds;
	}

	//User.ClientMessage("Press enter key to open car gates.");
	User.ReceiveLocalizedMessage(class'NVMessage', 9);
}

function UsedBy( Pawn user )
{
	if(User == None 
		|| User.IsA('MpMonkey')
		|| User.IsA('MpHeadcrab')
		|| User.IsA('NPVehicle')
		|| User.IsA('HelicopterVehicle')
		|| User.IsA('KVehicle')
		|| User.IsA('PostalMultiplayerChicken')
		|| User.IsA('PostalMultiplayerAirCraftVehicle'))
		return;

	if( GmcC4500Car(Owner) != None )
		GmcC4500Car(Owner).OpenGates();
}

defaultproperties
{
	 ReTriggerDelay=2.0
	 bAlwaysTick=true
	 bCollideActors=false
     RemoteRole=ROLE_None
     bCollideWhenPlacing=false
     CollisionRadius=30.0
     CollisionHeight=30.0
}
