//=============================================================================
// PlasmaProjectileRed.uc
// Author: Nick Pilshikov "Evil"
// Email: Nick_Pv@mail.ru / EvilTheDark@gmail.com
// Site: Set-Games.ru / Revival-Games.ru
// Revival Games Studios.
// 2014.
//=============================================================================

class PlasmaProjectileRed extends MinigunProjectile;

var bool bBlue;

var SpaceShipPlasmaActorRed Plasma;

replication
{
	unreliable if( Role == ROLE_Authority )
		Plasma;
}

simulated function PostBeginPlay()
{
	Super.PostBeginPlay();
	if( Level.NetMode != NM_Client )
	{
		if( !bBlue )
			Plasma = Spawn(class'SpaceShipPlasmaActorRed',self,,Location,Rotation);
		else Plasma = Spawn(class'SpaceShipPlasmaActorBlue',self,,Location,Rotation);
		Plasma.SetRotation(Rotation);
	}
	if( bBlue )
	{
		StaticImpactEffect=class'SpaceShipPlasmaImpactEffectBlue';
		MetalImpactEffect=class'SpaceShipPlasmaImpactEffectBlue';
	}
	else
	{
		StaticImpactEffect=class'SpaceShipPlasmaImpactEffectRed';
		MetalImpactEffect=class'SpaceShipPlasmaImpactEffectRed';
	}
}

simulated function Destroyed()
{
	Super.Destroyed();
	if( Plasma != None )
		Plasma.Destroy();
}

simulated function Tick(float DeltaTime)
{
	if( Plasma != None )
		Plasma.SetVelocity(Velocity);
	else Plasma = None;
}

defaultproperties
{
	 StaticImpactEffect=class'SpaceShipPlasmaImpactEffectRed'
	 MetalImpactEffect=class'SpaceShipPlasmaImpactEffectRed'
	 DamageAmmount=85.0
     FleshHit(0)=Sound'WeaponSounds.bullet_hitflesh1'
     FleshHit(1)=Sound'WeaponSounds.bullet_hitflesh2'
     FleshHit(2)=Sound'WeaponSounds.bullet_hitflesh3'
     FleshHit(3)=Sound'WeaponSounds.bullet_hitflesh4'
     BulletSounds(0)=Sound'MiscSounds.Doors.TryingLockedDoor'
     BulletSounds(1)=Sound'MiscSounds.Doors.TryingLockedDoor'
     BulletSounds(2)=Sound'MiscSounds.Doors.TryingLockedDoor'
     BulletSounds(3)=Sound'MiscSounds.Doors.TryingLockedDoor'
     PawnHitMarkerMade=Class'Postal2Game.PawnShotMarker'
     BulletHitMarkerMade=Class'Postal2Game.BulletHitMarker'
     FleshRad=350.000000
     speed=8000.000000
     MaxSpeed=8000.000000
     MomentumTransfer=50000.000000
     MyDamageType=Class'PlasmaDamage'
     Physics=PHYS_None
     DrawType=DT_StaticMesh
	 RemoteRole=ROLE_SimulatedProxy
     LifeSpan=10.000000
     TransientSoundRadius=400.000000
     bCollideActors=False
     bCollideWorld=False
     bBlockZeroExtentTraces=False
     bBlockNonZeroExtentTraces=False
}
