//=============================================================================
// SpaceShipPlasmaActorRed.uc
// Author: Nick Pilshikov "Evil"
// Email: Nick_Pv@mail.ru / EvilTheDark@gmail.com
// Site: Set-Games.ru / Revival-Games.ru
// Revival Games Studios.
// 2014.
//=============================================================================

class SpaceShipPlasmaActorRed extends Actor;

var Emitter PlasmaEffect;

var bool bBlue;

replication
{
	unreliable if( Role == ROLE_Authority )
		PlasmaEffect;
}

simulated function SetVelocity(vector newVelocity)
{
	Velocity = newVelocity;
	SetRotation(rotator(newVelocity));
}

simulated function PostBeginPlay()
{
	Super.PostBeginPlay();
	if( Level.NetMode != NM_Client )
	{
		if( !bBlue )
			PlasmaEffect = Spawn(class'SpaceShipPlasmaFireEffectRed',self,,Location,Rotation);
		else PlasmaEffect = Spawn(class'SpaceShipPlasmaFireEffectBlue',self,,Location,Rotation);
		PlasmaEffect.SetBase(self);
	}
}

simulated function Destroyed()
{
	Super.Destroyed();
	if( PlasmaEffect != None )
		PlasmaEffect.Destroy();
}

simulated function Tick(float DeltaTime)
{
	if( Level.NetMode == NM_Client )
	{
		if( PlasmaEffect != None )
		{
			PlasmaEffect.SetLocation(Location);
			PlasmaEffect.SetRotation(Rotation);
		}
		else PlasmaEffect = None;
	}
}

defaultproperties
{
	 NetUpdateFrequency=80
	 NetPriority=3.0
	 DrawType=DT_Mesh
	 RemoteRole=ROLE_SimulatedProxy
	 Physics=PHYS_Projectile
	 bReplicateMovement=true
     bNoDelete=False
}
