//=============================================================================
// xPRVCar. (Nicks karma based vehicle car class)
//
// Base model: model from UT2004 by EpicGames.
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2011.
//=============================================================================

class xPRVCar extends PRVCar;

simulated function UpdateMissileActors();
simulated function TurrelRotating();
simulated function DrawCrossHair(canvas Canvas);

simulated function SendEnterMessage(PlayerController PC)
{
	PC.ReceiveLocalizedMessage(class'NVMessage', 1);
	PC.ReceiveLocalizedMessage(class'NVMessage', 4);
}

simulated function PostBeginPlay()
{
	Super(NKVCar).PostBeginPlay();
}

simulated event DriverEnter(Pawn p)
{
	Super(NKVCar).DriverEnter(p);
}

simulated event DriverLeave(optional bool bDestroying)
{
	Super(NKVCar).DriverLeave(bDestroying);
}

simulated function VehicleHaveDriver()
{
	Super(NKVCar).VehicleHaveDriver();
}

function VehicleHaveNoDriver(optional bool bDestroying, optional bool bDriverFallOff)
{
	Super(NKVCar).VehicleHaveNoDriver(bDestroying, bDriverFallOff);
}

simulated function MonitorBehindView(PlayerController PC, bool bDriver)
{
	Super(NKVCar).MonitorBehindView(PC, bDriver);
}

simulated function ContinuousUpdate()
{
	Super(NKVCar).ContinuousUpdate();
}

simulated event ClientSimulationPack(optional bool LowRender)
{
	Super(NKVCar).ClientSimulationPack(LowRender);
}

simulated function TakeDamage(int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, class<DamageType> damageType)
{
	Super(NKVCar).TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
}

simulated function StartScriptedDriving(optional Actor myEnemy, optional Controller myEnemyContoller)
{
	Super(NKVCar).StartScriptedDriving(myEnemy, myEnemyContoller);
}

simulated function Destroyed()
{
	Super(NKVCar).Destroyed();
}

state VehicleDriving
{
	simulated function MainSystem(float DesiredSpeed)
	{
		local bool bDSR, bPSR;

		if(Passenger != None)
			bPSR = Passenger.bWantsToCrouch;

		if(Driver == None)
			return;

		bDSR = Driver.bWantsToCrouch;

		RadioSystem(bDSR, bPSR);
	}
}

defaultproperties
{
	 Tag="Hellbender"
	 MaxDesiredFOV=95.0
	 CameraDist=15.0
	 EngineVolume=70.0
}
