//=============================================================================
// NKVBoatTire. (Nicks vehicle boat tire class)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2011-2012.
//=============================================================================

class NKVBoatTire extends NKVCarTire;

simulated function Tick(float DeltaTime)
{
	local vector NormalImpulse, AdaptImpulse, MoveImpulse;
	local rotator NavyRotation;
	NavyRotation.Yaw = Chassis.Rotation.Yaw;
	if(IsInWater())
	{
		if( !WheelJoint.bKSteeringLocked )
		{
			if(Chassis.Steering != 0)
			{
				MoveImpulse.Y = 2048 * -Chassis.Steering;
				MoveImpulse = MoveImpulse >> NavyRotation;
				KAddImpulse(MoveImpulse, Location);
			}
			else
				MoveImpulse *= 0;
		}
		else
		{
			if(Chassis.Throttle != 0)
			{
				MoveImpulse.X = 2048 * Chassis.Throttle;
				MoveImpulse = MoveImpulse >> NavyRotation;
				KAddImpulse(MoveImpulse, Location);
			}
			else
				MoveImpulse *= 0;
		}
		NormalImpulse.Z = 4096;
		KAddImpulse(NormalImpulse, Location);
	}
	if(Chassis.Steering == 0 && Chassis.Throttle == 0)
	{
		if(VSize(Velocity) > 0)
		{
			AdaptImpulse = -Velocity * 2;
			//AdaptImpulse.Z = 0;
			KAddImpulse(AdaptImpulse, Location);
		}
		else
			AdaptImpulse *= 0;
	}
	if(Chassis.Steering == 0)
	{
		WheelJoint.KWake();
		WheelJoint.KBraking = Chassis.MaxBrakeTorque;
	}
	else
	{
		WheelJoint.KWake();
		WheelJoint.KBraking = 0.0;
	}
	if(Chassis.Throttle == 0)
	{
		WheelJoint.KWake();
		WheelJoint.KBraking = Chassis.MaxBrakeTorque;
	}
	else
	{
		WheelJoint.KWake();
		WheelJoint.KBraking = 0.0;
	}
}

defaultproperties
{
	 bBlockPlayers=False
	 bProjTarget=False
	 DrawScale=1.000000
}
