//=============================================================================
// NKVMissilePack.
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// T-ModZ. All Rights Reserved.
// 2012.
//=============================================================================

class NKVMissilePack extends NKVTurrel;

var int FireState;

var vector RocketLauncherOffset;

simulated function DisplayDebug(Canvas Canvas, out float YL, out float YPos)
{
	if( Chassis != None )
		Chassis.DisplayDebug(Canvas, YL, YPos);
}

simulated function DoBotFire(optional Actor EnemyTarget)
{
	local NKVMissileProjectile Rocket;
	local vector RotX, RotY, RotZ;
	local Actor myTarget;

    GetAxes(Rotation,RotX,RotY,RotZ);

	Instigator = DriverInstigator;

	if( EnemyTarget != None )
		myTarget = EnemyTarget;
	else myTarget = CheckOutTarget();

	if( FireState == 0 )
	{
		Rocket = spawn(class'NKVMissileProjectile',Instigator,,Location + RocketLauncherOffset.X * RotX + 
				RocketLauncherOffset.Y * RotY + RocketLauncherOffset.Z * RotZ);
		Rocket.SetupShot(10);
		Rocket.AddRelativeVelocity(Chassis.Velocity);

		if(myTarget != None)
			Rocket.SetNewTarget(myTarget);
		FireState = 1;
	}
	else
	{
		Rocket = spawn(class'NKVMissileProjectile',Instigator,,Location + RocketLauncherOffset.X * RotX - 
				RocketLauncherOffset.Y * RotY + RocketLauncherOffset.Z * RotZ);
		Rocket.SetupShot(10);
		Rocket.AddRelativeVelocity(Chassis.Velocity);

		if(myTarget != None)
			Rocket.SetNewTarget(myTarget);
		FireState = 0;
	}
}

simulated function xDoFire(bool bAutoDetection, optional Actor EnemyTarget)
{
	local NKVMissileProjectile Rocket;
	local vector RotX, RotY, RotZ;
	local Actor myTarget;

    GetAxes(Rotation,RotX,RotY,RotZ);

	Instigator = DriverInstigator;

	if( EnemyTarget != None )
		myTarget = EnemyTarget;
	else if( bAutoDetection )
		myTarget = CheckOutTarget();

	if( FireState == 0 )
	{
		Rocket = spawn(class'NKVMissileProjectile',Instigator,,Location + RocketLauncherOffset.X * RotX + 
				RocketLauncherOffset.Y * RotY + RocketLauncherOffset.Z * RotZ);
		Rocket.SetupShot(10);
		Rocket.AddRelativeVelocity(Chassis.Velocity);

		if(myTarget != None)
			Rocket.SetNewTarget(myTarget);
		FireState = 1;
	}
	else
	{
		Rocket = spawn(class'NKVMissileProjectile',Instigator,,Location + RocketLauncherOffset.X * RotX - 
				RocketLauncherOffset.Y * RotY + RocketLauncherOffset.Z * RotZ);
		Rocket.SetupShot(10);
		Rocket.AddRelativeVelocity(Chassis.Velocity);

		if(myTarget != None)
			Rocket.SetNewTarget(myTarget);
		FireState = 0;
	}
}

simulated function Pawn CheckOutTarget()
{
	local vector HitNormal;
	local vector ProjectedHitLoc;
	local Pawn FindTarget, ReturnTarget;
	local Actor TestTarget;

	if(Level.NetMode == NM_Standalone
		|| Level.NetMode == NM_ListenServer)
	{
		foreach AllActors(class'Pawn',FindTarget)
		{
			if( FindTarget != None && FindTarget.Health > 0 )
			{
				TestTarget = Trace(ProjectedHitLoc, HitNormal, FindTarget.Location, Location, true);
				if( TestTarget != None 
					&& Pawn(TestTarget) != None 
					&& Pawn(TestTarget).Health > 0 
					&& Pawn(TestTarget).Controller != None )
					break;
			}
		}
	}
	if( TestTarget != None 
		&& Pawn(TestTarget) != None 
		&& Pawn(TestTarget).Health > 0 
		&& Pawn(TestTarget).Controller != None)
		ReturnTarget = Pawn(TestTarget);

	return ReturnTarget;
}

defaultproperties
{
	 RocketLauncherOffset=(X=75.0,Y=33.0,Z=8.0)
	 StaticMesh=StaticMesh'MaricaCollision.PRVModel.MissilePack'
	 bHidden=false
	 bUnlit=false

	 bCollideActors=false
	 bCollideWorld=false
	 bReplicateInstigator=True
     bUpdateSimulatedPosition=True
     bGameRelevant=True
     NetPriority=3.000000
	 RemoteRole=ROLE_SimulatedProxy

     DrawType=DT_StaticMesh
}
