//=============================================================================
// NKVTank. (Generic tank vehicle, 10 wheels)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ
// T-ModZ. All Rights Reserved.
// 2011.
//=============================================================================

class NKVTank extends NKVehicle
	placeable;

var NKVTankTurrel Turrel;
var NKVTurrelRotator TurrelRotatorActor;
var(MaricaTank) class<NKVTankTurrel> TurrelClass;
var(MaricaTank) vector TurrelPos;
var(MaricaTank) class<Projectile> TurrelProjectileClass;
var(MaricaTank) class<Emitter> TurrelEffectClass;
var(MaricaTank) vector TurrelFireOffset, TurrelEffectOffset;
var(MaricaTank) float FireSpeed;
var float FireTime;
var(MaricaTank) sound FireSound;
var(MaricaTank) Material BaseIdleTread;
var(MaricaTank) Material ForwardIdleTread[5];
var(MaricaTank) Material BackwardsIdleTread[5];
var(MaricaTank) int RightTreadIndex;
var(MaricaTank) int LeftTreadIndex;
var int RightTreadMove;
var int LeftTreadMove;
var(MaricaTank) sound MovingSound;
var rotator ControllerRotation, OldTurrelRot;
var vector Dir;
var(MaricaTank) Name TurrelBone;
var rotator TurrelRotation, TurrelRotator;
var(MaricaTank) int TurrelRotFactor;
var float LeftTreadSpeed,RightTreadSpeed;
var bool bFireAction;

///FIX2015 execution
var(MaricaSkeleton) Name WheelAddl1Right;
var(MaricaSkeleton) Name WheelAddl1Left;
var(MaricaSkeleton) Name WheelAddl2Right;
var(MaricaSkeleton) Name WheelAddl2Left;
var(MaricaSkeleton) Name WheelAddl3Right;
var(MaricaSkeleton) Name WheelAddl3Left;
var(MaricaSkeleton) Name WheelAddl4Right;
var(MaricaSkeleton) Name WheelAddl4Left;
///FIX2015 execution

///FIX2015
var LaserDetectDot LaserDetector;
var(MaricaTank) Texture ReticleTexture;
var(MaricaTank) Color ReticleColor;
var(MaricaTank) float FireZ;
var(MaricaTank) int AimAngle;

var(MaricaTank) float TankFireVolume;

replication
{
	unreliable if( Role == ROLE_Authority )
		RightTreadMove , LeftTreadMove , Dir , ControllerRotation , TurrelRotator , 
		Turrel , LeftTreadSpeed , RightTreadSpeed , bFireAction , OldTurrelRot , LaserDetector;
}

function SpawnLights();
function DestroyLights();

function UpdateHeadLights()
{
	if( LightProjector != None )
	{
		LightProjector.Destroy();
		LightProjector = None;
	}
}

simulated function PostBeginPlay()
{
	local vector RotX, RotY, RotZ, lPos;

    GetAxes(Rotation,RotX,RotY,RotZ);
	if(Level.NetMode != NM_Client)
	{
		TurrelRotatorActor = spawn(class'NKVTurrelRotator', self,, Location);
		Turrel = spawn(TurrelClass, self,, Location + (TurrelPos >> Rotation));
		Turrel.SetBase(self);
		Turrel.Chassis = self;
		Turrel.FiringAmmunition = TurrelProjectileClass;
		Turrel.FireOffset = TurrelFireOffset;
		Turrel.EffectOffset = TurrelEffectOffset;
		Turrel.EffectClass = TurrelEffectClass;
	}
	if(GameIsSingle())
		FPViewPointOwner = Turrel;
	else
	{
		FPDriverViewPos = FPViewAltPos;
		FPViewPointOwner = self;
		bFixedFPCamera = False;
	}
	Super.PostBeginPlay();
	SwitchMessageType();
}

simulated event DriverEnter(Pawn p)
{
	local PlayerController PC;
	local rotator ViewRotation;

	if(p == None)
		return;

	Driver = p;

	PC = PlayerController(Driver.Controller);
	PC.SetCollision( PC.default.bCollideActors, PC.default.bBlockActors, PC.default.bBlockPlayers );
	Driver.SetCollision(true, false, false);
	Driver.bCollideWorld = false;
	Driver.SetLocation(Location + (DriverPos >> Rotation));
	Driver.bHidden = True;
	Driver.bPhysicsAnimUpdate = false;
	Driver.Velocity = vect(0,0,0);
	Driver.SetPhysics(PHYS_None);
	if(DriverBase != None)
	{
		//DriverBase.SetFixedPosition(True);
		Driver.SetBase(DriverBase);
	}
	else Driver.SetBase(self);
	if(PC != None)
	{
		ViewRotation = PC.Rotation;
		ViewRotation.Yaw = Turrel.Rotation.Yaw;
		PC.ReceiveLocalizedMessage(class'NVMessage', 1);
		PC.ReceiveLocalizedMessage(class'NVMessage', 7);
		PC.ClientSetBehindView(True);
		PC.bBehindView = true;
		PC.ClientSetViewTarget(self);
		PC.ClientSetRotation(ViewRotation);
		PC.MyHUD.bShowDebugInfo = True;
		PC.CameraDist = CameraDist;
		bDriverGodMode = PC.bGodMode;
		if( bDriverGodMode )
			bImmortal = true;
		if( !bDriverTakesDamage )
			PC.bGodMode = true;
	}
	GotoState('BeforeBeStart');

	IntCollision.AmbientSound = EngineSound;

	if(Turrel != None)
		Turrel.DriverInstigator = Driver;
	CheckLevelTravelObject(p, true);
}

simulated event DriverEnterTravel(Pawn p, rotator DriverViewRotation)
{
	local PlayerController PC;
	local rotator ViewRotation;
	if(p == None)
		return;
	Driver = p;
	PC = PlayerController(Driver.Controller);
	Driver.SetCollision(true, false, false);
	Driver.bCollideWorld = false;
	Driver.SetLocation(Location + (DriverPos >> Rotation));
	Driver.bHidden = True;
	Driver.bPhysicsAnimUpdate = false;
	Driver.Velocity = vect(0,0,0);
	Driver.SetPhysics(PHYS_None);
	if(DriverBase != None)
	{
		//DriverBase.SetFixedPosition(True);
		Driver.SetBase(DriverBase);
	}
	else Driver.SetBase(self);
	if(PC != None)
	{
		ViewRotation = PC.Rotation;
		ViewRotation.Yaw = Turrel.Rotation.Yaw;
		//PC.ReceiveLocalizedMessage(class'ProjectMaricaCore.NVMessage', 1);
		//PC.ReceiveLocalizedMessage(class'ProjectMaricaCore.NVMessage', 6);
		PC.ClientSetBehindView(True);
		PC.bBehindView = true;
		PC.ClientSetViewTarget(self);
		PC.ClientSetRotation(ViewRotation);
		PC.MyHUD.bShowDebugInfo = True;
		PC.CameraDist = CameraDist;
		bDriverGodMode = PC.bGodMode;
		if( bDriverGodMode )
			bImmortal = true;
		if( !bDriverTakesDamage )
			PC.bGodMode = true;
	}

	IntCollision.AmbientSound = EngineSound;

	if(Turrel != None)
		Turrel.DriverInstigator = Driver;
	CheckLevelTravelObject(p, true);
	GotoState('VehicleDriving');
}

simulated function VehicleHaveDriver()
{
	if(myShadow != None)
	{
		myShadow.bInstantUpdate = True;
		myShadow.bAcceptRender = True;
	}
	Super.VehicleHaveDriver();
	if(Turrel != None)
		Turrel.DriverInstigator = Driver;
}

function VehicleHaveNoDriver(optional bool bDestroying, optional bool bDriverFallOff)
{
	Super.VehicleHaveNoDriver(bDestroying, bDriverFallOff);
	if(myShadow != None)
	{
		myShadow.bInstantUpdate = False;
		myShadow.bAcceptRender = False;
	}
	if(Turrel != None)
		Turrel.DriverInstigator = None;
}

simulated event DriverLeave(optional bool bDestroying)
{
	local Pawn ownOldDriver;
	ownOldDriver = Driver;
	Super.DriverLeave(bDestroying);
	if(Turrel != None)
		Turrel.DriverInstigator = None;
	RightTreadMove = 0;
	LeftTreadMove = 0;
	CheckLevelTravelObject(ownOldDriver, false);
}

simulated function UpdateTreads()
{
	local rotator ReCRot;
	local int Sign, tempSide;
	local float absRightTreadSpeed, absLeftTreadSpeed;

	if(GameIsEnd())
	{
		Skins[RightTreadIndex] = BaseIdleTread;
		Skins[LeftTreadIndex] = BaseIdleTread;
		return;
	}

	if(Role == ROLE_Authority)
	{
		ReCRot = rotator(Velocity) - Rotation;
		if(ReCRot.yaw > 16384 || ReCRot.yaw < -16384)
			Sign = -1;
		else
			Sign = 1;
		if(SteerTireRight != None)
			RightTreadSpeed = SteerTireRight.SpinSpeed;
		if(SteerTireRight != None)
			LeftTreadSpeed = SteerTireLeft.SpinSpeed;
	}

	//if( Driver != None )
	//	Driver.ClientMessage(RightTreadSpeed);

	///FIX2015
	tempSide = LeftTreadIndex;
	absRightTreadSpeed = abs(RightTreadSpeed);
	if( absRightTreadSpeed > 70000 )
	{
		if( absRightTreadSpeed > 70000 && absRightTreadSpeed < 90000 )
		{
			if( RightTreadSpeed > 0 )
				Skins[tempSide] = ForwardIdleTread[0];
			else Skins[tempSide] = BackwardsIdleTread[0];
		}
		else if( absRightTreadSpeed > 90000 && absRightTreadSpeed < 110000 )
		{
			if( RightTreadSpeed > 0 )
				Skins[tempSide] = ForwardIdleTread[1];
			else Skins[tempSide] = BackwardsIdleTread[1];
		}
		else if( absRightTreadSpeed > 110000 && absRightTreadSpeed < 130000 )
		{
			if( RightTreadSpeed > 0 )
				Skins[tempSide] = ForwardIdleTread[2];
			else Skins[tempSide] = BackwardsIdleTread[2];
		}
		else if( absRightTreadSpeed > 130000 && absRightTreadSpeed < 150000 )
		{
			if( RightTreadSpeed > 0 )
				Skins[tempSide] = ForwardIdleTread[3];
			else Skins[tempSide] = BackwardsIdleTread[3];
		}
		else if( absRightTreadSpeed > 150000 )
		{
			if( RightTreadSpeed > 0 )
				Skins[tempSide] = ForwardIdleTread[4];
			else Skins[tempSide] = BackwardsIdleTread[4];
		}
	}
	else Skins[tempSide] = BaseIdleTread;

	tempSide = RightTreadIndex;
	absLeftTreadSpeed = abs(LeftTreadSpeed);
	if( absLeftTreadSpeed > 70000 )
	{
		if( absLeftTreadSpeed > 70000 && absLeftTreadSpeed < 90000 )
		{
			if( LeftTreadSpeed > 0 )
				Skins[tempSide] = ForwardIdleTread[0];
			else Skins[tempSide] = BackwardsIdleTread[0];
		}
		else if( absLeftTreadSpeed > 90000 && absLeftTreadSpeed < 110000 )
		{
			if( LeftTreadSpeed > 0 )
				Skins[tempSide] = ForwardIdleTread[1];
			else Skins[tempSide] = BackwardsIdleTread[1];
		}
		else if( absLeftTreadSpeed > 110000 && absLeftTreadSpeed < 130000 )
		{
			if( LeftTreadSpeed > 0 )
				Skins[tempSide] = ForwardIdleTread[2];
			else Skins[tempSide] = BackwardsIdleTread[2];
		}
		else if( absLeftTreadSpeed > 130000 && absLeftTreadSpeed < 150000 )
		{
			if( LeftTreadSpeed > 0 )
				Skins[tempSide] = ForwardIdleTread[3];
			else Skins[tempSide] = BackwardsIdleTread[3];
		}
		else if( absLeftTreadSpeed > 150000 )
		{
			if( LeftTreadSpeed > 0 )
				Skins[tempSide] = ForwardIdleTread[4];
			else Skins[tempSide] = BackwardsIdleTread[4];
		}
	}
	else Skins[tempSide] = BaseIdleTread;
	///FIX2015
}

simulated function ClientSimulationPack(optional bool LowRender)
{
	UpdateSimulatedPosition(LowRender);
	if(!LowRender)
		UpdateDriverActors();
	SetBlockKarma();
}

simulated function GetVehicleData(optional bool bOnlyPositon)
{
	local rotator ChassisRot;

	if(Role == ROLE_Authority)
		ChassisRot = Rotation;

	if(Level.NetMode != NM_Client)
	{
		ServerPosition = Location;
		ServerRotation = ChassisRot;
	}

	if(bOnlyPositon)
		return;

	if (Role == ROLE_Authority)
	{
		if(SteerTireRight != None)
			Tire1RotT = SteerTireRight.Rotation;
		if(SteerTireLeft != None)
			Tire2RotT = SteerTireLeft.Rotation;
		if(EngTireRight != None)
			Tire3RotT = EngTireRight.Rotation;
		if(EngTireLeft != None)
			Tire4RotT = EngTireLeft.Rotation;
		if(Turrel != None)
			TurrelRotator.Yaw = Turrel.Rotation.Yaw - Rotation.Yaw;
		Dir = vector(Rotation);
	}
}

simulated function PlayFiring()
{
	if( FireSound != None )
		PlaySound(FireSound, SLOT_Misc, TankFireVolume);
}

simulated function ApplyVehicleData()
{
	if(Driver != None && myShadow != None)
	{
		myShadow.bInstantUpdate = True;
		myShadow.bAcceptRender = True;
	}
	if(!GameIsEnd())
		UpdateTreads();
	//RIGHT TREAD
	// 1
	if(WheelFrontRight != '')
		SetBoneDirection(WheelFrontRight,Tire1RotT,Dir,1);
	// 3
	if(WheelRearRight != '')
		SetBoneDirection(WheelRearRight,Tire1RotT,Dir,1);//Tire3RotT
	// 5
	if(WheelCrossRight != '')
		SetBoneDirection(WheelCrossRight,Tire1RotT,Dir,1);
	// 7
	if(WheelPlusRight != '')
		SetBoneDirection(WheelPlusRight,Tire1RotT,Dir,1);
	// 9
	if(WheelAddl1Right != '')
		SetBoneDirection(WheelAddl1Right,Tire1RotT,Dir,1);
	// 11
	if(WheelAddl2Right != '')
		SetBoneDirection(WheelAddl2Right,Tire1RotT,Dir,1);
	// 13
	if(WheelAddl3Right != '')
		SetBoneDirection(WheelAddl3Right,Tire1RotT,Dir,1);
	// 15
	if(WheelAddl4Right != '')
		SetBoneDirection(WheelAddl4Right,Tire1RotT,Dir,1);

	//LEFT TREAD
	// 2
	if(WheelFrontLeft != '')
		SetBoneDirection(WheelFrontLeft,Tire2RotT,Dir,1);
	// 4
	if(WheelRearLeft != '')
		SetBoneDirection(WheelRearLeft,Tire2RotT,Dir,1);//Tire4RotT
	// 6
	if(WheelCrossLeft != '')
		SetBoneDirection(WheelCrossLeft,Tire2RotT,Dir,1);
	// 8
	if(WheelPlusLeft != '')
		SetBoneDirection(WheelPlusLeft,Tire2RotT,Dir,1);
	// 10
	if(WheelAddl1Left != '')
		SetBoneDirection(WheelAddl1Left,Tire2RotT,Dir,1);
	// 12
	if(WheelAddl2Left != '')
		SetBoneDirection(WheelAddl2Left,Tire2RotT,Dir,1);
	// 14
	if(WheelAddl3Left != '')
		SetBoneDirection(WheelAddl3Left,Tire2RotT,Dir,1);
	// 16
	if(WheelAddl4Left != '')
		SetBoneDirection(WheelAddl4Left,Tire2RotT,Dir,1);
	// Turrel
	if(TurrelBone != '')
		SetBoneRotation(TurrelBone,TurrelRotator,0,1);
}

simulated function ContinuousUpdate()
{
	local DriverSceneWatchScript SceneWatchScript;

	if( Driver == None || GameIsEnd() )
	{
		TurrelRotating();
		Skins[RightTreadIndex] = BaseIdleTread;
		Skins[LeftTreadIndex] = BaseIdleTread;
	}

	NETUpdatePriority();

	if( bPlayCrash )
	{
		PlayCrash();
		bPlayCrash = false;
	}

	if( bFireAction )
	{
		PlayFiring();
		bFireAction = false;
	}

	if(GameIsEnd())
	{
		MatchEnd();
		bHideHUD = True;
	}

	CheckPawns();

	if(Driver != None && Driver.Controller != None)
		DriverController = PlayerController(Driver.Controller);

	if( DriverController != None && DriverController.bInterpolating )
	{
		SceneWatchScript = spawn(class'DriverSceneWatchScript');
		SceneWatchScript.DriverPC = DriverController;
		SceneWatchScript.bWasGodMode = bDriverGodMode;
		DriverLeave();
		DriverController = None;
		return;
	}

	if(Passenger != None && Passenger.Controller != None)
		PassengerController = PlayerController(Passenger.Controller);

	if(!bAIControlled)
	{
		if(Level.NetMode == NM_Client)
			UserInterfaceControl();
		else if(Level.NetMode != NM_DedicatedServer)
			UserInterfaceControl();
	}

	if(Level.NetMode != NM_Client)
		mySpeed = VSize(Velocity);

	if(CurrentSkin != None && Skins[SkinIndex] != CurrentSkin)
		Skins[SkinIndex] = CurrentSkin;

	if(IsGoingToUpdate()
		|| Driver != None
		|| Passenger != None
		|| Enemy != None)
	{
		GetVehicleData(False);
		ApplyVehicleData();
		if(Level.NetMode == NM_Client)
			ClientSimulationPack(False);
	}
	else
	{
		GetVehicleData(True);
		if(Level.NetMode == NM_Client)
			ClientSimulationPack(True);
	}
}

///FIX2015
simulated function Actor CalcFireDirection()
{
	local vector Target, StartLoc, HitLocation, DetectDotPos, HitNormal;
	local Actor Other;
	local rotator CurrentOrient;

	CurrentOrient = Turrel.Rotation;

	if( Driver != None && Driver.Controller != None )
		CurrentOrient.Pitch = Driver.Controller.Rotation.Pitch;
	//else CurrentOrient = Rotation;

	StartLoc = Location + ((FireZ * vect(0,0,1)) >> CurrentOrient);
	//spawn(class'PistolPuff',,,StartLoc);
	CurrentOrient.Pitch += AimAngle;

	Target = Location + (vect(65536,0,0) >> CurrentOrient);

	Other = Trace(HitLocation, HitNormal, Target, StartLoc, true);

	if( VSize(HitLocation) == 0 )
		HitLocation = Location + (vect(65536,0,0) >> CurrentOrient);

	if( VSize(HitLocation - Location) < 800 )
		HitLocation = Location + (vect(800,0,0) >> CurrentOrient);

	if( LaserDetector != None )
	{
		DetectDotPos = (vect(40,0,0) >> rotator(Location-HitLocation)) + HitLocation;
		//DetectDotPos = HitLocation;
		LaserDetector.SetLocation(DetectDotPos);
	}

	//LastCalcWeaponFire = Level.TimeSeconds;

	return Other;
}

simulated function TurrelRotating()
{
	local rotator FinalRotation, NecessaryRotation;
	if( Turrel == None
		|| TurrelRotatorActor == None )
		return;

	///FIX2015
	if( Driver != None )
	{
		if( LaserDetector == None )
			LaserDetector = spawn(class'LaserDetectDot',self,,Location);
		CalcFireDirection();
	}
	else
	{
		if( LaserDetector != None )
		{
			LaserDetector.Destroy();
			LaserDetector = None;
		}
	}
	///FIX2015

	if( Driver != None && Driver.Controller != None )
		ControllerRotation.Yaw = PlayerController(Driver.Controller).Rotation.Yaw;

	if( Driver == None )
		NecessaryRotation = OldTurrelRot;

	if( Driver != None && Driver.Controller != None )
	{
		FinalRotation = Normalize((Normalize(ControllerRotation) - Normalize(TurrelRotatorActor.Rotation))) * TurrelRotFactor; 

		TurrelRotatorActor.RotationRate = Normalize(FinalRotation);
		TurrelRotatorActor.DesiredRotation = ControllerRotation;

		NecessaryRotation.Yaw = TurrelRotatorActor.Rotation.Yaw - Rotation.Yaw;
		TurrelRotation = NecessaryRotation;
	}
	else if( Driver == None )
	{
		FinalRotation = Normalize((Normalize(Turrel.Rotation) - Normalize(TurrelRotatorActor.Rotation))) * TurrelRotFactor; 

		TurrelRotatorActor.RotationRate = Normalize(FinalRotation);
		TurrelRotatorActor.DesiredRotation = Turrel.Rotation;
	}

	Turrel.SetRelativeRotation(NecessaryRotation);
	OldTurrelRot = TurrelRotation;
}

state VehicleDriving
{
	simulated function Tick(float DeltaTime)
	{
		ContinuousUpdate();
		if(Driver == None)
			return;
		PlayerInput();
		MainSystem(mySpeed);
		DrivingSimulation(mySpeed);
	}

	simulated function FiringSystem(bool DriverInput)
	{
		local vector FireMoment;
		local rotator FireImpulseDir;

		if( Turrel == None )
			return;

		TurrelRotating();

		FireImpulseDir = Turrel.Rotation;

		if( DriverInput )
		{
			if( Level.TimeSeconds > FireTime + FireSpeed )
			{
				///FIX2015
				if( LaserDetector != None )
					Turrel.DoOrientFire(rotator(LaserDetector.Location-Turrel.Location));
				else Turrel.DoFire();
				bFireAction = true;
				FireMoment.X = 700;
				FireMoment = -FireMoment * 800;
				FireMoment = FireMoment >> FireImpulseDir;
				KAddImpulse(FireMoment,Location);
				FireTime = Level.TimeSeconds;
			}
		}
	}

	simulated function MainSystem(float DesiredSpeed)
	{
		local bool bDSR;
		local bool bPSR;

		if( Passenger != None )
			bPSR = Passenger.bWantsToCrouch;

		if(Driver == None)
			return;

		bDSR = Driver.bWantsToCrouch || Driver.PressingFire();

		FiringSystem(bDSR);
		RadioSystem(bPSR);
	}

	function RadioSystem(optional bool DriverInput, optional bool PassengerInput)
	{
		if(/*!bAllowRadio &&*/ RadioSong.Length == 0)
			return;
		if(DriverInput || PassengerInput)
		{
			if(Level.TimeSeconds > RadioUpdateTime + RadioSwitchSpeed)
			{
				if(RadioSongNumber < RadioSong.Length)
				{
					if( Level.NetMode != NM_Client )
					{
						CurrentSong = RadioSong[RadioSongNumber];
						SwitchSong();
					}
					RadioSongNumber++;
					if(RadioSwitchSound != None)
						PlaySound(RadioSwitchSound, SLOT_Misc, RadioSwitchVolume);
				}
				else //if(RadioSongNumber > RadioSong.Length)
				{
					CurrentSong = None;
					RadioSongNumber = 0;
					SwitchSong();
				}
				RadioUpdateTime = Level.TimeSeconds;
			}
		}
	}

	simulated function HandsTryToFire()
	{
		if( Driver == None )
			return;
		FiringSystem(true);
	}

	function DrivingSimulation(float DesiredSpeed)
	{
		local float RotAng , RotMove;

		if(Driver == None)
			return;

		if(DesiredSpeed > 1100)
			RotAng = 1.0;
		else
			RotAng = 1.5;

		RotMove = Throttle * MaxSpeedAccel * RotAng;
		if(bCarIsRTWD)
		{
			EngTireRight.WheelJoint.KMotorTorque = RotMove;
			EngTireLeft.WheelJoint.KMotorTorque = RotMove;
			if( CrossTireClass != None )
			{
				CrossTireRight.WheelJoint.KMotorTorque = RotMove;
				CrossTireLeft.WheelJoint.KMotorTorque = RotMove;
			}
		}
		if(bCarIsFTWD)
		{
			SteerTireRight.WheelJoint.KMotorTorque = RotMove;
			SteerTireLeft.WheelJoint.KMotorTorque = RotMove;
			if( CrossTireClass != None )
			{
				CrossTireRight.WheelJoint.KMotorTorque = RotMove;
				CrossTireLeft.WheelJoint.KMotorTorque = RotMove;
			}
		}

		if(Throttle == 1)
		{
			IntCollision.AmbientSound = MovingSound;
			if(Steering == 1)
			{
				EngTireLeft.WheelJoint.KWake();
				SteerTireLeft.WheelJoint.KWake();
				EngTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
				SteerTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
				CrossTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
				EngTireLeft.LateralFriction = 0.0;
				SteerTireLeft.LateralFriction = 0.0;
				RightTreadMove = 0;
			}
			else
			{
				EngTireLeft.WheelJoint.KBraking = 0.0;
				SteerTireLeft.WheelJoint.KBraking = 0.0;
				CrossTireLeft.WheelJoint.KBraking = 0.0;
				EngTireLeft.LateralFriction = TireLateralFriction;
				SteerTireLeft.LateralFriction = TireLateralFriction;
				RightTreadMove = 1;
			}
			if(Steering == -1)
			{
				EngTireRight.WheelJoint.KWake();
				SteerTireRight.WheelJoint.KWake();
				EngTireRight.WheelJoint.KBraking = MaxBrakeTorque;
				SteerTireRight.WheelJoint.KBraking = MaxBrakeTorque;
				CrossTireRight.WheelJoint.KBraking = MaxBrakeTorque;
				EngTireRight.LateralFriction = 0.0;
				SteerTireRight.LateralFriction = 0.0;
				LeftTreadMove = 0;
			}
			else
			{
				EngTireRight.WheelJoint.KBraking = 0.0;
				SteerTireRight.WheelJoint.KBraking = 0.0;
				CrossTireRight.WheelJoint.KBraking = 0.0;
				EngTireRight.LateralFriction = TireLateralFriction;
				SteerTireRight.LateralFriction = TireLateralFriction;
				LeftTreadMove = 1;
			}
			if(bCarIsRTWD)
			{
				EngTireRight.WheelJoint.KWake();
				EngTireLeft.WheelJoint.KWake();
				EngTireRight.KWake();
				EngTireLeft.KWake();
				if( CrossTireClass != None )
				{
					CrossTireRight.WheelJoint.KWake();
					CrossTireLeft.WheelJoint.KWake();
					CrossTireRight.KWake();
					CrossTireLeft.KWake();
				}
			}
			if(bCarIsFTWD)
			{
				SteerTireRight.WheelJoint.KWake();
				SteerTireLeft.WheelJoint.KWake();
				SteerTireRight.KWake();
				SteerTireLeft.KWake();
				if( CrossTireClass != None )
				{
					CrossTireRight.WheelJoint.KWake();
					CrossTireLeft.WheelJoint.KWake();
					CrossTireRight.KWake();
					CrossTireLeft.KWake();
				}
			}
		}
		else if(Throttle == -1)
		{
			IntCollision.AmbientSound = MovingSound;
			if(Steering == 1)
			{
				EngTireLeft.WheelJoint.KWake();
				SteerTireLeft.WheelJoint.KWake();
				EngTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
				SteerTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
				CrossTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
				EngTireLeft.LateralFriction = 0.0;
				SteerTireLeft.LateralFriction = 0.0;
				RightTreadMove = 0;
			}
			else
			{
				EngTireLeft.WheelJoint.KBraking = 0.0;
				SteerTireLeft.WheelJoint.KBraking = 0.0;
				CrossTireLeft.WheelJoint.KBraking = 0.0;
				EngTireLeft.LateralFriction = TireLateralFriction;
				SteerTireLeft.LateralFriction = TireLateralFriction;
				RightTreadMove = -1;
			}
			if(Steering == -1)
			{
				EngTireRight.WheelJoint.KWake();
				SteerTireRight.WheelJoint.KWake();
				EngTireRight.WheelJoint.KBraking = MaxBrakeTorque;
				SteerTireRight.WheelJoint.KBraking = MaxBrakeTorque;
				CrossTireRight.WheelJoint.KBraking = MaxBrakeTorque;
				EngTireRight.LateralFriction = 0.0;
				SteerTireRight.LateralFriction = 0.0;
				LeftTreadMove = 0;
			}
			else
			{
				EngTireRight.WheelJoint.KBraking = 0.0;
				SteerTireRight.WheelJoint.KBraking = 0.0;
				CrossTireRight.WheelJoint.KBraking = 0.0;
				EngTireRight.LateralFriction = TireLateralFriction;
				SteerTireRight.LateralFriction = TireLateralFriction;
				LeftTreadMove = -1;
			}
			if(bCarIsRTWD)
			{
				EngTireRight.WheelJoint.KWake();
				EngTireLeft.WheelJoint.KWake();
				EngTireRight.KWake();
				EngTireLeft.KWake();
				if( CrossTireClass != None )
				{
					CrossTireRight.WheelJoint.KWake();
					CrossTireLeft.WheelJoint.KWake();
					CrossTireRight.KWake();
					CrossTireLeft.KWake();
				}
			}
			if(bCarIsFTWD)
			{
				SteerTireRight.WheelJoint.KWake();
				SteerTireLeft.WheelJoint.KWake();
				SteerTireRight.KWake();
				SteerTireLeft.KWake();
				if( CrossTireClass != None )
				{
					CrossTireRight.WheelJoint.KWake();
					CrossTireLeft.WheelJoint.KWake();
					CrossTireRight.KWake();
					CrossTireLeft.KWake();
				}
			}
		}
		else
		{
			IntCollision.AmbientSound = EngineSound;
			EngTireRight.WheelJoint.KWake();
			EngTireLeft.WheelJoint.KWake();
			SteerTireRight.WheelJoint.KWake();
			SteerTireLeft.WheelJoint.KWake();
			EngTireRight.WheelJoint.KBraking = MaxBrakeTorque;
			EngTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
			SteerTireRight.WheelJoint.KBraking = MaxBrakeTorque;
			SteerTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
			CrossTireRight.WheelJoint.KBraking = MaxBrakeTorque;
			CrossTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
			RightTreadMove = 0;
			LeftTreadMove = 0;
		}
		KWake();
		UpdateRearLight();
	}
}

function VehicleUpdateParams()
{
    Super.VehicleUpdateParams();
    SteerTireRight.WheelJoint.bKSteeringLocked = True;
    SteerTireLeft.WheelJoint.bKSteeringLocked = True;
}

simulated function UpdateBrakes()
{
	if(Driver == None && !IsInWater())
	{
		EngTireRight.WheelJoint.KWake();
		EngTireLeft.WheelJoint.KWake();
		SteerTireRight.WheelJoint.KWake();
		SteerTireLeft.WheelJoint.KWake();
		CrossTireRight.WheelJoint.KWake();
		CrossTireLeft.WheelJoint.KWake();
		EngTireRight.WheelJoint.KBraking = MaxBrakeTorque;
		EngTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
		SteerTireRight.WheelJoint.KBraking = MaxBrakeTorque;
		SteerTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
		CrossTireRight.WheelJoint.KBraking = MaxBrakeTorque;
		CrossTireLeft.WheelJoint.KBraking = MaxBrakeTorque;
		RightTreadMove = 0;
		LeftTreadMove = 0;
	}
	else
	{
		EngTireRight.WheelJoint.KWake();
		EngTireLeft.WheelJoint.KWake();
		SteerTireRight.WheelJoint.KWake();
		SteerTireLeft.WheelJoint.KWake();
		CrossTireRight.WheelJoint.KWake();
		CrossTireLeft.WheelJoint.KWake();
		EngTireRight.WheelJoint.KBraking = 0.0;
		EngTireLeft.WheelJoint.KBraking = 0.0;
		SteerTireRight.WheelJoint.KBraking = 0.0;
		SteerTireLeft.WheelJoint.KBraking = 0.0;
		CrossTireRight.WheelJoint.KBraking = 0.0;
		CrossTireLeft.WheelJoint.KBraking = 0.0;
	}
}

simulated function Destroyed()
{
	if( Turrel != None )
		Turrel.Destroy();

	if( TurrelRotatorActor != None )
		TurrelRotatorActor.Destroy();

	///FIX2015
	if( LaserDetector != None )
		LaserDetector.Destroy();

	Super.Destroyed();
}

function TakeDamage(int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, class<DamageType> damageType)
{
	local int actualDamage;
	local Controller Killer;
	local vector RotX, RotY, RotZ, ShootMomentum;
    GetAxes(Rotation,RotX,RotY,RotZ);

	if(Health > 0)
	{
		if(Driver != None && !bDriverTakesDamage)
		{
			if(Driver.Health <= 0)
			{
				DriverForceLeave();
				VehicleHaveNoDriver();
			}
		}
		if(Passenger != None)
		{
			if(Passenger.Health <= 0)
			{
				PassengerForceLeave();
				VehicleHaveNoPassenger();
			}
		}
	}

	if(bImmortal)
		return;

	if( damageType == class'BaseFX.BurnedDamage'
		|| damageType == class'BaseFX.SmashDamage'
		|| damageType == class'BaseFX.OnFireDamage'
		|| damageType == class'BaseFX.KickingDamage'
		|| damageType == class'BaseFX.BludgeonDamage' 
		|| damageType == class'NVExplodeCarDamage' )
		return;

	if(ClassIsChildOf(damageType, class'BaseFX.ExplodedDamage'))
	{
		Health -= damage * 5;
	}

	if(ClassIsChildOf(damageType, class'Engine.Crushed'))
	{
		Health -= damage;
	}

	if(damageType == class'BaseFX.ElectricalDamage'
		|| damageType == class'ProjectMaricaCore.NVRepairDamage')
	{
		if(Health < MaxHealth)
			Health += 25;
		if(Health >= 600)
		{
			if(VehicleSmoke != None)
			{
				VehicleSmoke.Destroy();
				EnginePitch = EnginePitch + 5;
			}
		}
		if(Health >= 250)
		{
			if(NVEngFire != None)
				NVEngFire.Destroy();
		}
	}

	if(damageType == class'BaseFX.BulletDamage')
	{
		if(instigatedBy == Driver)
			return;
		else
			Health -= damage / 8;
	}

	if(ClassIsChildOf(damageType, class'BaseFX.ShotGunDamage')
		|| ClassIsChildOf(damageType, class'BaseFX.MachineGunDamage')
		|| ClassIsChildOf(damageType, class'BaseFX.RifleDamage'))
	{
		Health -= damage / 8;
	}

	DamagedCarEngine();

	if(Health <= 0)
	{
		if(instigatedBy != None)
			Killer = instigatedBy.GetKillerController();

		if(Driver != None && Driver.Health > 0)
		{
			if( !bDriverTakesDamage )
			{
				DriverForceLeave();
				Driver.Controller.bGodMode = false;
				if(GameIsSingle())
					Driver.Died( Killer, class'InVehicleDamage', HitLocation );
				else
					Driver.Died( Killer, class'InVehicleDamageMP', HitLocation );//Gibbed
				VehicleHaveNoDriver(true);
			}
			else
			{
				DriverLeave(true);
			}
		}
		if(Passenger != None && Passenger.Health > 0)
		{
			PassengerForceLeave();
			Passenger.Controller.bGodMode = False;
			if(GameIsSingle())
				Passenger.Died( Killer, class'InVehicleDamage', HitLocation );
			else
				Passenger.Died( Killer, class'Gibbed', HitLocation );
			VehicleHaveNoPassenger();
		}
		if(bSpawnBrokenDetail)
			GotoState('BeforeBeDestroyed');
		else
			GotoState('ForceDestroy');
	}
	else
	{
		if(VSize(momentum) < 0.001)
			return;

		if(IsInWater())
			ShootMomentum = Momentum / 512;
		else
			ShootMomentum = Momentum / 256;
		KAddImpulse(ShootMomentum,HitLocation);
	}
}

simulated function PlayCrash()
{
	local NKVehicle CrashedCar;

	if( ImpactInfo.Other != None )
	{
		if( NKVehicle(ImpactInfo.Other) != None )
			CrashedCar = NKVehicle(ImpactInfo.Other); 
		else if( NKVehicleTire(ImpactInfo.Other) != None )
			CrashedCar = NKVehicleTire(ImpactInfo.Other).Chassis;
	}

	if( ImpactInfo.Speed > 100 )
	{
		if( CrashedCar != None )
		{
			KImpactPlaySound(3000,1.2,800);
			return;
		}
		KImpactPlaySound(ImpactInfo.Speed);
	}
}

simulated function TakeImpactDamage(Actor Other, vector Pos, float CrashSpeed, float MyVelocity, float OtherVelocity)
{
	local float OtherDamage;
	local NKVehicleTire CrashedCarTire;

	if( CrashSpeed > 100 )
	{
		OtherDamage = CrashSpeed * 10;

		if( Other != None )
		{
			CrashedCarTire = NKVehicleTire(Other);
			if( CrashedCarTire != None && CrashedCarTire.Chassis != None )
				Other = CrashedCarTire.Chassis;
			if( VSize(Velocity) > 200 && !Other.IsA('NKVTank') )
				Other.TakeDamage(OtherDamage, Instigator, Location, Velocity*5, class'ExplodedDamage');
		}
	}
}

//simulated function DrawCDPlayerInfo(Canvas Canvas);
simulated function DrawCDPlayerInfo(Canvas Canvas)
{
	local Color TempColor;
	local string SongName;
	local int n;
	local rotator NewRot;
	local float ColorFact, XL, YL;
	local float X,Y,tempTexSize;
	local Texture tempTex;

	if( CurrentSong == None )
		return;

	TempColor.R = 255;
	TempColor.G = 255;
	TempColor.B = 255;
	TempColor.A = HUDOpacity;
	Canvas.DrawColor = TempColor;

	tempTexSize = 0.6 * Canvas.ClipY/1024;
	tempTex = CDTex;
	X = HUDLocX * Canvas.ClipX - (tempTexSize*tempTex.USize/2);
	Y = HUDLocCDY * Canvas.ClipY - (tempTexSize*tempTex.VSize/2);
	Canvas.bCenter = false;
	Canvas.Style = ERenderStyle.STY_Alpha;
	Canvas.SetDrawColor(255,255,255,255);
	Canvas.SetPos(X, Y);
	Canvas.DrawIcon(tempTex, tempTexSize);

	if( CurrentSong != None )//DriverBase != None && DriverBase.AmbientSound != None
	{
		SongName = ""$CurrentSong;
		n = InStr(""$CurrentSong,".")+1;
		SongName = Right(SongName, Len(SongName) - n);
		ReplaceText(SongName, "_", " ");
	}
	else SongName = PlayerText1;

	X = HUDLocX * Canvas.ClipX + (tempTexSize*tempTex.USize/1.5);
	Y = HUDLocCDY * Canvas.ClipY - (tempTexSize*tempTex.VSize/4);

	Canvas.Font = Canvas.MedFont;
	Canvas.bCenter = false;
	Canvas.Style = ERenderStyle.STY_Alpha;
	Canvas.SetDrawColor(25,25,25,180);
	Canvas.SetPos(X+2.0, Y+2.0);
	Canvas.DrawText(SongName, false);

	Canvas.Font = Canvas.MedFont;
	Canvas.bCenter = false;
	Canvas.Style = 5;
	Canvas.DrawColor = TempColor;
	Canvas.Font = Canvas.MedFont;
	Canvas.SetPos(X, Y);
	Canvas.DrawText(SongName, false);
}

function CheckLevelTravelObject(Pawn ownDriver, bool bSetOwnVehicle)
{
	//local MaricaLevelTravelObject tempTravelObject;
	local NKVHandsWeapon tempVehicleHands;

	if( ownDriver == None || P2Pawn(ownDriver) == None )
		return;

	/*if( LevelTravelObject == None )
	{
		tempTravelObject = MaricaLevelTravelObject(ownDriver.FindInventoryType(class'MaricaLevelTravelObject'));

		if( tempTravelObject != None )
			LevelTravelObject = tempTravelObject;
		else LevelTravelObject = MaricaLevelTravelObject(P2Pawn(ownDriver).CreateInventoryByClass(class'MaricaLevelTravelObject'));
	}*/

	if( !bAllowWeaponsInside && bSetOwnVehicle )
	{
		tempVehicleHands = NKVHandsWeapon(ownDriver.FindInventoryType(class'NKVHandsWeapon'));

		if( tempVehicleHands == None )
			myVehicleHands = NKVHandsWeapon(P2Pawn(ownDriver).CreateInventoryByClass(class'NKVHandsWeapon'));
		else myVehicleHands = tempVehicleHands;

		myVehicleHands.myOldWeapon = ownDriver.Weapon;
		myVehicleHands.myVehicle = self;
	}

	/*if( LevelTravelObject == None )
		return;

	if( bSetOwnVehicle )
	{
		LevelTravelObject.myVehicle = self;
		LevelTravelObject.TravelCarClass = Class;

		if( Skins[SkinIndex] != None )
			LevelTravelObject.TravelCarSkin = Skins[SkinIndex];

		LevelTravelObject.TravelCarHealth = Health;
		LevelTravelObject.DriverViewPitch = ownDriver.Controller.Rotation.Pitch;
	}
	else
	{
		LevelTravelObject.myVehicle = None;
		LevelTravelObject.TravelCarSkin = None;
		LevelTravelObject.TravelCarSongNum = 0;
		LevelTravelObject.TravelCarClass = None;
	}*/
}

/********************************************************************************
* Converts a given directional vector to canvas coordinates.                    *
* X and Y values of the returned vector contain absolute coordinates.           *
* The function returns, whether the target direction is visible for the player. *
* Created by Wormbo                                                             *
********************************************************************************/
simulated function bool WormbosMapToHUD(out vector Result, rotator ViewRotation, float FOV, vector TargetDir, Canvas Canvas)
{
	local float TanFOVx, TanFOVy;
	local float TanX, TanY;
	local float dx, dy;
	local vector X, Y, Dir, XY;
 
	TanFOVx = Tan(FOV * Pi / 360);
	TanFOVy = (Canvas.ClipY / Canvas.ClipX) * TanFOVx;
	GetAxes(ViewRotation, Dir, X, Y);
 
	Dir *= TargetDir dot Dir;
	XY = TargetDir - Dir;
	dx = XY dot X;
	dy = XY dot Y;
 
	TanX = dx / VSize(dir);
	TanY = dy / VSize(dir);
 
	Result.X = Canvas.ClipX * 0.5 * (1 + TanX / TanFOVx);
	Result.Y = Canvas.ClipY * 0.5 * (1 - TanY / TanFOVy);
 
	return Dir dot vector(ViewRotation) > 0 && Result.X == FClamp(Result.X, Canvas.OrgX, Canvas.ClipX)
			&& Result.Y == FClamp(Result.Y, Canvas.OrgY, Canvas.ClipY);
}

simulated function DrawCrossHair( canvas Canvas)
{
	local P2Player p2p;
	local float UseScale;
	local Texture CrossHair;
	local vector CamPos, DrawLoc;
	local rotator CamRot;

	if( Driver == None )
		return;

	p2p = P2Player(Driver.Controller);

	if( p2p == None )
		return;

	if( ReticleTexture != None && LaserDetector != None && p2p != None )
	{
		// Draw reticle
		UseScale = P2Hud(p2p.MyHud).Scale;

		Canvas.Style = ERenderStyle.STY_Alpha;
		Canvas.DrawColor = ReticleColor;
		CrossHair = ReticleTexture;

		Canvas.GetCameraLocation(CamPos, CamRot);
		WormbosMapToHUD(DrawLoc, CamRot, p2p.FOVAngle, LaserDetector.Location-CamPos, Canvas);

		Canvas.SetPos((DrawLoc.X) - UseScale*(CrossHair.USize/2), (DrawLoc.Y) - UseScale*(CrossHair.VSize/2));

		Canvas.DrawIcon(CrossHair, UseScale);
	}
}

simulated function DisplayDebug(Canvas Canvas, out float YL, out float YPos)
{
	if( !bDebugHUD )
		DrawCrossHair(Canvas);
	Super.DisplayDebug(Canvas, YL, YPos);
}

/*
     SuspHighLimit=0.100000
     SuspLowLimit=-0.100000
     SuspStiffness=9.000000
     SuspDamping=20.000000
*/

defaultproperties
{
	 FireZ=190.0
	 AimAngle=3500
	 ReticleColor=(R=255,G=255,B=255,A=220)
	 ReticleTexture=Texture'P2Misc.Reticle.Reticle_Crosshair_WhiteLine'

	 Tag="Tank"
	 ShadowZ=0.0
	 TankFireVolume=3.0
     ActionFriction=0.2
     RestFriction=0.000001
	 MaxBrakeTorque=65
	 MaxDesiredFOV=90.0
	 ActionAngularDamp=0.0
	 RestAngularDamp=2.75

	 ImpactSoundsMin(0)=Sound'MaricaSounds.ut_impact_03'
	 ImpactSoundsMed(0)=Sound'MaricaSounds.ut_impact_01'
	 ImpactSoundsMed(1)=Sound'MaricaSounds.ut_impact_02'
	 ImpactSoundsMax(0)=Sound'MaricaSounds.ut_impact_04'
	 ImpactSoundsMax(1)=Sound'MaricaSounds.ut_impact_05'
	 ImpactSoundsMax(2)=Sound'MaricaSounds.ut_impact_06'
	 ImpactSoundsMax(3)=Sound'MaricaSounds.ut_impact_07'

	 TurrelRotFactor=1
	 TurrelBone="Top"
	 bAllowChangeView=True
	 bFixedFPCamera=True
     Health=8192.000000
     MaxHealth=8192.000000
	 FireSpeed=2
	 FireSound=Sound'MaricaSounds.ut_fire_tank_01'
	 Description="Base tank class. || Model by RWS and Evil (Nick)."
	 ShadowLightDistance=1800.0
	 ShadowMaxTraceDistance=512.0
	 ShadowLightDirection=(X=1.0,Y=1.0,Z=12.0)

	 bAllowBrokenWheels=False
	 bSpawnBrokenDetail=True
	 BaseIdleTread=Texture'MaricaTextures.TankNickTex.TankTread'
	 ForwardIdleTread(0)=TexPanner'MaricaTextures.TankNickTex.TankTread_fd_speed01'
	 ForwardIdleTread(1)=TexPanner'MaricaTextures.TankNickTex.TankTread_fd_speed02'
	 ForwardIdleTread(2)=TexPanner'MaricaTextures.TankNickTex.TankTread_fd_speed03'
	 ForwardIdleTread(3)=TexPanner'MaricaTextures.TankNickTex.TankTread_fd_speed04'
	 ForwardIdleTread(4)=TexPanner'MaricaTextures.TankNickTex.TankTread_fd_speed05'
	 BackwardsIdleTread(0)=TexPanner'MaricaTextures.TankNickTex.TankTread_bw_speed01'
	 BackwardsIdleTread(1)=TexPanner'MaricaTextures.TankNickTex.TankTread_bw_speed02'
	 BackwardsIdleTread(2)=TexPanner'MaricaTextures.TankNickTex.TankTread_bw_speed03'
	 BackwardsIdleTread(3)=TexPanner'MaricaTextures.TankNickTex.TankTread_bw_speed04'
	 BackwardsIdleTread(4)=TexPanner'MaricaTextures.TankNickTex.TankTread_bw_speed05'
	 RightTreadIndex=4
	 LeftTreadIndex=2

	 TurrelClass=Class'ProjectMarica.NKVTankTurrel'
	 TurrelPos=(X=-65.000000,Z=46.000000)
	 TurrelProjectileClass=Class'TankProjectile'
	 TurrelEffectClass=Class'NKVTankFireEffect'
	 TurrelFireOffset=(X=600.000000,Y=-5.000000,Z=20.000000)
	 TurrelEffectOffset=(X=600.000000,Y=-5.000000,Z=20.000000)

	 bUpdateSusp=False
	 RSuspHighLimit=0.000000
	 RSuspLowLimit=0.000000
     ExitPos=(Y=-225.000000,Z=15.000000)
     ExitPosPassenger=(Y=225.000000,Z=15.000000)
     EnterPos=(Y=225.000000)
	 WheelFrontRight="RightTire1"
	 WheelFrontLeft="LeftTire1"
	 WheelAddl1Right="RightTire2"
	 WheelAddl1Left="LeftTire2"
	 WheelAddl2Right="RightTire3"
	 WheelAddl2Left="LeftTire3"
	 WheelAddl3Right="RightTire4"
	 WheelAddl3Left="LeftTire4"
	 WheelAddl4Right="RightTire5"
	 WheelAddl4Left="LeftTire5"
	 WheelCrossRight="RightTire6"
	 WheelCrossLeft="LeftTire6"
	 WheelPlusRight="RightTire7"
	 WheelPlusLeft="LeftTire7"
	 WheelRearRight="RightTire8"
	 WheelRearLeft="LeftTire8"

	 IntCollisionSize=(X=1,Y=1,Z=1)
	 IntCollisionModel=StaticMesh'MaricaCollision.TankColl.TankIntCollision'
	 IntCollisionClass=Class'ProjectMaricaCore.IntCollisionActor'

     CameraDist=10.000000
     MaxSpeedAccel=40.000000
     bCarIsRTWD=True
     bCarIsFTWD=True
	 VehicleMaxSpeed=183837.500000
     ChassisMass=6.0000000

	 bCanSeeDriver=False
	 DriverPos=(X=-26.000000,Y=-36.000000,Z=5.400000)
	 FPDriverViewPos=(X=30.000000,Y=-5.000000,Z=110.000000)
	 FPViewAltPos=(X=-65.0,Y=0.0,Z=135.0)
	 FPPassengerViewPos=(X=-65.0,Y=0.0,Z=135.0)
	 PassengerPos=(X=-26.000000,Y=36.000000,Z=5.400000)

	 RadiatorPos=(X=-300.000000,Y=0.000000,Z=80.000000)
     VehicleFireClass=Class'ProjectMaricaCore.VehicleFireEmitter'

	 bDamagableWheels=False
	 bSparkWheels=False
     EngTireClass=Class'NKVTankTire'
     SteerTireClass=Class'NKVTankTire'
	 CrossTireClass=Class'NKVTankTire'
     WheelSteerAlong=228.000000
     WheelSteerAcross=135.000000
     WheelEngAlong=-235.000000
     WheelEngAcross=135.000000
     WheelCrossAlong=0.000000
     WheelCrossAcross=135.000000
     WheelVert=-75.000000
     SuspHighLimit=0.3
     SuspLowLimit=-0.3
     SuspStiffness=200.000000
     SuspDamping=5.000000
     TireRollFriction=3.000000
     TireLateralFriction=1.800000

	 MovingSound=Sound'MaricaSounds.ut_engine_idle_tank_02'
	 EnginePitch=64
     EngineSound=Sound'MaricaSounds.ut_engine_idle_tank_01'
     //EngStartUpSound=Sound'MaricaSounds.ut_engine_start_tank_01'
     //EngStopSound=Sound'MaricaSounds.ut_engine_stop_tank_01'
     EngStartUpSound=None
     EngStopSound=None

	 bRandomSkin=False
	 SkinIndex=1
     StaticMesh=StaticMesh'MaricaCollision.TankColl.TankKCollision'
	 Mesh=SkeletalMesh'MaricaModels.TankNick'
	 OtherSkins(0)=Texture'MaricaTextures.TankNickTex.Tank_Skin01'
	 Skins(0)=Texture'MaricaTextures.TankNickTex.Tank_Top_Skin01'
	 Skins(1)=Texture'MaricaTextures.TankNickTex.Tank_Skin01'
	 BrokenSkins(0)=Texture'MaricaTextures.TankNickTex.Tank_Top_Skin01'
	 BrokenSkins(1)=Texture'MaricaTextures.TankNickTex.Tank_Skin01'
	 Mass=1000.000000
     CollisionRadius=80.000000
     CollisionHeight=80.000000

     Begin Object Class=KarmaParamsRBFull Name=NKVTankPhysics
         KInertiaTensor(0)=20.000000
         KInertiaTensor(3)=30.000000
         KInertiaTensor(5)=48.000000
         KCOMOffset=(X=0.300000,Z=-2.850000)
         KLinearDamping=0.000000
         KAngularDamping=0.750000
         KStartEnabled=True
         bKNonSphericalInertia=True
         KFriction=0.200000
         KImpactThreshold=300.000000
         Name="NKVTankPhysics"
     End Object
     KParams=KarmaParamsRBFull'NKVTankPhysics'
}
