//=============================================================================
// NicksWaterInfo. (Special fluid surface info)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2010.
//=============================================================================

class NicksWaterInfo extends FluidSurfaceInfo
	placeable;

var() class<Emitter> ShootEffect;
var() bool OrientShootEffect;

function TakeDamage(int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, class<DamageType> damageType)
{
	Super.TakeDamage(Damage, instigatedBy, hitlocation, 
						momentum, damageType);

	Pling(hitLocation, ShootStrength, 0);

	if(ShootEffect != None)
	{
		if(OrientShootEffect)
			spawn(ShootEffect, self, , hitLocation, rotator(momentum));
		else
			spawn(ShootEffect, self, , hitLocation);
	}
}

function Touch(Actor Other)
{
	local vector touchLocation;

	Super(Info).Touch(Other);

	if(Other.bDisturbFluidSurface == false)
		return;

	touchLocation = Other.Location;
	touchLocation.Z = Location.Z;

	Pling(touchLocation, TouchStrength, Other.CollisionRadius);
}

defaultproperties
{
	 ShootEffect=Class'WaterSplash'
	 OrientShootEffect=True
	 bUnlit=True
	 bAcceptsProjectors=True
	 bBlockZeroExtentTraces=True
	 bBlockNonZeroExtentTraces=True
	 bNoDelete=True
	 bMovable=True
     FluidGridType=FGT_Square
     FluidGridSpacing=350.000000
     FluidXSize=32
     FluidYSize=32
     FluidHeightScale=4.000000
     FluidSpeed=150.000000
     FluidDamping=0.500000
     FluidNoiseFrequency=0.500000
     FluidNoiseStrength=(Min=-35.000000,Max=35.000000)
     TestRippleSpeed=3000.000000
     TestRippleStrength=-20.000000
     TestRippleRadius=48.000000
     UTiles=1.000000
     VTiles=1.000000
     AlphaHeightScale=10.000000
     AlphaMax=128
     ShootStrength=-20.000000
     RippleVelocityFactor=-0.050000
     TouchStrength=-300.000000
     WarmUpTime=2.000000
     UpdateRate=50.000000
     bHidden=False
     DrawType=DT_FluidSurface
     Texture=Texture'ProjectMaricaCore.EvilsWaterInfo'
     bCollideActors=True
     bProjTarget=True
}
