//=============================================================================
// PMCop. (ProjectMarica's multiplayer npc bystanders)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2011.
//=============================================================================

class PMBystander extends PMPawn;

var() array<Mesh> 		MeshHead;
var() array<Mesh> 		MeshBody;
var() array<Texture>	MeshBodySkin;
var() array<StaticMesh> NewBoltons;
var() array<Texture>	MeshHeadSkin;

var Texture NETSkin;
var Texture NETHeadSkin;

replication
{
	unreliable if( Role == ROLE_Authority )
		NETSkin , NETHeadSkin;
}

simulated function PostBeginPlay()
{
	local Mesh CurMesh;
	local int nRand;

	nRand = Rand(MeshHead.Length);
	HeadMesh = MeshHead[nRand];
	NETHeadSkin = MeshHeadSkin[nRand];
	HeadSkin = NETHeadSkin;

	nRand = Rand(MeshBody.Length);
	CurMesh = MeshBody[nRand];
	NETSkin = MeshBodySkin[nRand];
	Skins[0] = NETSkin;

	SetupAppearance();
	SetupHead();
	SetupBoltons();
	SetupAnims();
	SetupDialog();
	SetupCollisionInfo();

	Super.PostBeginPlay();

	SetMyMesh(CurMesh,, True);
}

simulated function Tick(float DeltaTime)
{
	if( Health > 0 && !bDeleteMe )
	{
		if( Skins[0] != NETSkin )
			Skins[0] = NETSkin;
		if( myHead != None && !myHead.bDeleteMe && myHead.Skins[0] != NETHeadSkin )
			myHead.Skins[0] = NETHeadSkin;
	}
	Super.Tick(DeltaTime);
}

simulated function Notify_StartPuking()
{
	if(MyHead != None)
	{
		//Head(MyHead).StartPuking(PukeType);

		// tell controller you started actually spewing chunks
		if(PersonController(Controller) != None)
			PersonController(Controller).ActuallyPuking();
	}
}

function SetupHead()
{
	local rotator rot;
	local vector v;

	if (HeadClass != None)
	{
		if (myHead == None)
		{
			myHead = spawn(HeadClass, self,,Location);
			if (myHead != None)
			{
				// Attach to body
				AttachToBone(myHead, BONE_HEAD);
			}
		}

		if (myHead != None)
		{
			// Setup the head
			myHead.Setup(HeadMesh, HeadSkin, HeadScale, AmbientGlow);
			//myHead.LinkMesh(HeadMesh);

			// Rotate head so it looks right (this is temporary until the editor's
			// animation browser supports attachment sockets)
			rot.Pitch = 0;
			rot.Yaw = -16384;	// -18000 looks better but leaves a gap at back of neck!
			rot.Roll = 16384;
			myHead.SetRelativeRotation(rot);

			// Push the heads down a hair to hide the seam
			v.x = ADJUST_RELATIVE_HEAD_Z;
			v.y = 0;
			v.z = 0;
			myHead.SetRelativeLocation(v);
			myHead.Instigator = self;
		}
	}
	else
		Warn("No HeadClass defined for "$self);
}

simulated function Destroyed()
{
	Super.Destroyed();
	if(myHead != None)
		myHead.Destroy();
}

defaultproperties
{
	 Cajones=0.050000
	 MaxMoneyToStart=25.000000
	 Health=50.000000
	 Rat=1.000000
     WarnPeople=1.000000
     BodyHitSounds(0)=Sound'MiscSounds.People.bodyhitground1'
     BodyHitSounds(1)=Sound'MiscSounds.People.bodyhitground2'
     ChameleonMeshPkgs(0)="Characters"
     ChamelHeadSkins(0)="ChamelHeadSkins.MWA__001__AvgMale"
     ChamelHeadSkins(1)="ChamelHeadSkins.MBA__013__AvgBrotha"
     ChamelHeadSkins(2)="ChamelHeadSkins.MBA__014__AvgBrotha"
     ChamelHeadSkins(3)="ChamelHeadSkins.MMA__016__AvgMale"
     ChamelHeadSkins(4)="ChamelHeadSkins.MMF__024__FatMale"
     ChamelHeadSkins(5)="ChamelHeadSkins.MWA__002__AvgMale"
     ChamelHeadSkins(6)="ChamelHeadSkins.MMA__003__AvgMale"
     ChamelHeadSkins(7)="ChamelHeadSkins.MWA__004__AvgMale"
     ChamelHeadSkins(8)="ChamelHeadSkins.MWA__005__AvgMale"
     ChamelHeadSkins(9)="ChamelHeadSkins.MWA__006__AvgMale"
     ChamelHeadSkins(10)="ChamelHeadSkins.MWA__007__AvgMale"
     ChamelHeadSkins(11)="ChamelHeadSkins.MWA__008__AvgMale"
     ChamelHeadSkins(12)="ChamelHeadSkins.MWA__009__AvgMale"
     ChamelHeadSkins(13)="ChamelHeadSkins.MWA__010__AvgMale"
     ChamelHeadSkins(14)="ChamelHeadSkins.MWA__011__AvgMale"
     ChamelHeadSkins(15)="ChamelHeadSkins.MWA__015__AvgMale"
     ChamelHeadSkins(16)="ChamelHeadSkins.MWA__021__AvgMaleBig"
     ChamelHeadSkins(17)="ChamelHeadSkins.MWA__035__AvgMale"
     ChamelHeadSkins(18)="ChamelHeadSkins.MWF__025__FatMale"
     ChamelHeadSkins(19)="ChamelHeadSkins.MWA__022__AvgMaleBig"
     ChamelHeadSkins(20)="ChamelHeadSkins.FBA__033__FemSH"
     ChamelHeadSkins(21)="ChamelHeadSkins.FMA__028__FemSH"
     ChamelHeadSkins(22)="ChamelHeadSkins.FMA__034__FemSH"
     ChamelHeadSkins(23)="ChamelHeadSkins.FWA__026__FemLH"
     ChamelHeadSkins(24)="ChamelHeadSkins.FWA__027__FemLH"
     ChamelHeadSkins(25)="ChamelHeadSkins.FWA__029__FemSH"
     ChamelHeadSkins(26)="ChamelHeadSkins.FWA__032__FemSH"
     ChamelHeadSkins(27)="ChamelHeadSkins.FWF__023__FatFem"
     ChamelHeadSkins(28)="ChamelHeadSkins.FWA__037__FemSHcropped"
     ChamelHeadSkins(29)="ChamelHeadSkins.FMA__038__FemSHcropped"
     ChamelHeadSkins(30)="ChamelHeadSkins.FMA__039__FemSHcropped"
     ChamelHeadSkins(31)="ChamelHeadSkins.FWA__040__FemSHcropped"
     ChamelHeadSkins(32)="ChamelHeadSkins.MBF__042__FatMale"
     ChamelHeadSkins(33)="ChamelHeadSkins.FBF__043__FatFem"
     ChamelHeadSkins(34)="ChamelHeadSkins.FMF__044__FatFem"
     ChamelHeadSkins(35)="ChamelHeadSkins.FWA__031__FemSH"
     ChamelHeadSkins(36)="ChamelHeadSkins.FBA__063__FemSH"
     ChamelHeadSkins(37)="End"
     ChamelHeadMeshPkgs(0)="heads"
     BaseEquipment(0)=(WeaponClass=Class'Inventory.HandsWeapon')
     BaseEquipment(1)=(WeaponClass=Class'Inventory.FootWeapon')
     BaseEquipment(2)=(WeaponClass=Class'Inventory.UrethraWeapon')
     bCanPickupInventory=True
     HandsClass=Class'Inventory.HandsWeaponSS'
     HandsTexture=None
	 ControllerClass=Class'AIPack.BystanderController'
     MenuName="Bystander"
}
