//=============================================================================
// PMMarketTrigger.
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2012.
//=============================================================================

class PMMarketTrigger extends Actor
	placeable;

var() int DealCost;
var P2Pawn PotentialCustomer;
var bool bCashierExist;
var bool MessageExist;

auto state WaitForCustomer
{
	simulated function Tick(float DeltaTime)
	{
		local Controller C;
		local PlayerController PC;
		local int CustomersMoney;
		local P2MoCapPawn P2MCP;
		local MoneyInv Bucks;

		if(PotentialCustomer != None)
		{
			C = PotentialCustomer.Controller;
			PC = PlayerController(C);
		}
		else
			MessageExist = False;
		if(PotentialCustomer == None || !C.bIsplayer)
			return;
		P2MCP = P2MoCapPawn(PotentialCustomer);
			if(P2MCP.FindInventoryType(class'MoneyInv') != None)
				Bucks = MoneyInv(P2MCP.FindInventoryType(class'MoneyInv'));
		CustomersMoney = PotentialCustomer.HowMuchInventory(class'MoneyInv');
		if(CustomersMoney <= 0 || CustomersMoney < DealCost)
		{
			if(!MessageExist)
			{
				PC.ReceiveLocalizedMessage(class'ProjectMarica.PMMarketMessage', 2);
				MessageExist = True;
			}
			return;
		}
		if(!MessageExist)
		{
			PC.ReceiveLocalizedMessage(class'ProjectMarica.PMMarketMessage', 0);
			MessageExist = True;
		}

		//log("Customer's money is "$CustomersMoney);

		if(Bucks.IsInState('Activated'))
		{
			//log("Ready to service");
			GoToState('ServiceCustomer');
		}
	}
}

state ServiceCustomer
{
	ignores Tick, Touch;
	function bool Paid()
	{
		local P2MoCapPawn P2MCP;
		local MoneyInv Bucks;
		P2MCP = P2MoCapPawn(PotentialCustomer);
			if(P2MCP.FindInventoryType(class'MoneyInv') != None)
			{
				Bucks = MoneyInv(P2MCP.FindInventoryType(class'MoneyInv'));
				Bucks.ReduceAmount(DealCost);
				return true;
			}
		return false;
	}
	simulated function BeginState()
	{
		local int i;
		local PlayerController PC;
		local P2MoCapPawn P2MCP;
		local Inventory Inv;
		local P2Weapon Weap;
		local P2PowerupInv PU;
		local int NumberOfItemsGiven;
		if(Paid())
		{
			PC = PlayerController(PotentialCustomer.Controller);
			TriggerEvent(Event, self, PotentialCustomer);

			PC.ReceiveLocalizedMessage(class'ProjectMarica.PMMarketMessage', 1);
			//log("Deal over");
			GoToState('WaitForCustomer');
		}
	}
}

simulated function Touch(Actor Other)
{
	if(Other != None)
	{
		if(Other == Pawn(Other))
		{
			PotentialCustomer = P2Pawn(Other);
			//log("Customer is "$PotentialCustomer);
		}
	}
}

simulated function UnTouch(Actor Other)
{
	if(Pawn(Other) == PotentialCustomer)
	{
		PotentialCustomer = None;
		//log("Customer is gone damn!");
	}
}

defaultproperties
{
	 bHidden=True
     DealCost=10
     Texture=Texture'P2Misc.Icons.S_cashreg'
	 bCollideActors=True
	 CollisionRadius=20.000000
	 CollisionHeight=20.000000
}
