//=============================================================================
// PMPawnRespawner. (Special spawner of multiplayer npcs)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2011.
//=============================================================================

class PMPawnRespawner extends Actor
	placeable;

var() class<PMPawn> PawnClass;
var() int MaxPawnsCount;
var	int	PawnsCount, HardNoPoint;
var() bool bRealTimeSpawn;
var() bool bRandomLocated;
var() edfindable array<NavigationPoint> SpawnPoint;

event Trigger( Actor Other, Pawn EventInstigator )
{
	if(!bRealTimeSpawn)
		SpawnNewPawn();
}

function Tick(float DeltaTime)
{
	if(bRealTimeSpawn)
		SpawnNewPawn();
}

simulated function SpawnNewPawn()
{
	local int a;
	local PMPawn CreatedPawn;
	local NavigationPoint CurrentPoint;

	if(PawnsCount >= MaxPawnsCount)
		return;

	if(PawnClass != None)
	{
		if(bRandomLocated && SpawnPoint.Length > 0)
		{
			a = PawnsCount + rand(4);

			if( SpawnPoint.Length > a )
				a = SpawnPoint.Length - rand(2);

			a = FClamp(a,0,SpawnPoint.Length-1);

			if( HardNoPoint > 0 )
			{
				if( a + HardNoPoint <= (SpawnPoint.Length-1) )
					a += HardNoPoint;
				else a = FClamp(a-HardNoPoint,0,SpawnPoint.Length-1);
			}

			CurrentPoint = SpawnPoint[a];
			if(CurrentPoint != None)
			{
				CreatedPawn = spawn(PawnClass, , , CurrentPoint.Location+(PawnClass.Default.CollisionHeight - CurrentPoint.CollisionHeight) * vect(0,0,1), CurrentPoint.Rotation);
				if(CreatedPawn != None)
				{
					HardNoPoint = 0;
					PawnsCount++;
				}
				else
				{
					HardNoPoint++;
					return;
				}
				CreatedPawn.PR = self;
				log("Spawned: "$CreatedPawn$" num "$PawnsCount);
				AddController(CreatedPawn);
			}
		}
		else
		{
			CreatedPawn = spawn(PawnClass, , , Location, Rotation);
			PawnsCount++;
			CreatedPawn.PR = self;
			AddController(CreatedPawn);
		}

	}
}

simulated function AddController(P2Pawn PMPawn)
{
	local PersonController PersC;
	if ( PMPawn.Controller == None && PMPawn.Health > 0 )
	{
		if ( (PMPawn.ControllerClass != None))
			PMPawn.Controller = spawn(PMPawn.ControllerClass);
		PersC = PersonController(PMPawn.Controller);
		if ( PMPawn.Controller != None )
			PMPawn.Controller.Possess(PMPawn);
		PMPawn.CheckForAIScript();
		PersC.GotoState('Thinking');
	}
}

defaultproperties
{
	 bRealTimeSpawn=True
     MaxPawnsCount=1
     bHidden=True
     bNoDelete=True
     RemoteRole=ROLE_None
     bDirectional=True
     PawnClass=Class'ProjectMaricaCore.PMPawn'
}
