class ProjectMaricaMenuEditBox extends UWindowEditBox;

var int AscKey;
var bool bHaveShellIcons;

function bool Insert(byte C)
{
	Value = Chr(C);

	if(bDelayedNotify)
		bChangePending = True;
	else
		Notify(DE_Change);
	return True;
}

function Created()
{
	Super.Created();

	bHaveShellIcons = ( DynamicLoadObject("FPSGame.FPSButtonInfo", class'Class') != None );
}

function Paint(Canvas C, float X, float Y)
{
	local float W, H, fFullW, fFullH;
	local float TextY;
	local float fAlignOff;
	
	C.Font = Root.Fonts[Font];

	TextSize(C, "A", W, H);
	TextY = (WinHeight - H) / 2;

	TextSize(C, Left(Value, CaretOffset), W, H);

	C.SetDrawColor(255,255,255);
	
	if(W + Offset < 0)
		Offset = -W;

	if(W + Offset > (WinWidth - 2))
	{
		Offset = (WinWidth - 2) - W;
		if(Offset > 0) Offset = 0;
	}

	C.DrawColor = TextColor;

	// RWS CHANGE: 02/02/03 JMI Added adjustment when alignment is centered or right.
	switch (Align)
	{
	case TA_Center:
		TextSize(C, Value, fFullW, fFullH);
		fAlignOff = (WinWidth - fFullW) / 2;
		break;
	case TA_Right:
		TextSize(C, Value, fFullW, fFullH);
		fAlignOff = (WinWidth - fFullW);
		break;
	case TA_Left:
	default:
		fAlignOff = 0;
		break;
	}

	if( bHaveShellIcons )
	{
		if( GetPlayerOwner().MyHud != None && Value != "" )
		{
			AscKey = Asc(Caps(Value));
			FPSHUD(GetPlayerOwner().MyHud).MyFont.DrawText(C, "%KEY_"$AscKey$"%", 1.0);
		}
	}
	else ClipText(C, fAlignOff + Offset + 1, TextY,  Caps(Value));
}

function bool Backspace()
{
	if(bDelayedNotify)
		bChangePending = True;
	else
		Notify(DE_Change);
	return True;
}

function bool Delete()
{
	Notify(DE_Change);
	return True;
}

defaultproperties
{
}