//=============================================================================
// DriverActorNPV. (Special actor that looks like a driver)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2011.
//=============================================================================

class DriverActorNPV extends Actor
	notplaceable;

const 	PAWN_HEAD_BONE	=	'MALE01 head';
var MeshAnimation DrivingAnims;
var Mesh BodyModel;
var Material BodySkin;
var NPVehicle myVehicle;
var Name CurrentAnim;

replication
{
	unreliable if (Role == ROLE_Authority)
		myVehicle, CurrentAnim, BodyModel, BodySkin;
}

simulated function UpdateStuff()
{
	if(BodyModel == None)
		return;

	if(BodySkin == None)
		BodySkin = myVehicle.Driver.Skins[0];

	if(BodySkin != None)
		Skins[0] = BodySkin;

	// hack, we have head from driver
	if( myVehicle.Driver != None && myVehicle.Driver.myHead != None )
	{
		myVehicle.Driver.DetachFromBone(myVehicle.Driver.myHead);
		AttachToBone(myVehicle.Driver.myHead, PAWN_HEAD_BONE);
		MpPawn(myVehicle.Driver).myHead.SetOwner(self);
	}

	if(DrivingAnims != None)
		LinkSkelAnim(DrivingAnims);

	CurrentAnim = myVehicle.DrivingAnimStatus;

	if(Mesh != None && CurrentAnim != 'None')
		LoopAnim(CurrentAnim,1.0);

	SetPhysics(PHYS_None);
}

simulated function Tick(float DeltaTime)
{
	local name anim;
	local float frame,rate;

	if(myVehicle == None)
		return;

	if( Level.NetMode != NM_DedicatedServer )
		GetAnimParams(0,Anim,frame,rate);

	if(Mesh == None || Anim != CurrentAnim)
	{
		if(BodyModel == None)
			BodyModel = myVehicle.FindPawnModel();

		LinkMeshAndAnims(BodyModel, True);
		UpdateStuff();
	}
}

simulated function LinkMeshAndAnims(Mesh NewMesh, optional bool bKeepAnimState)
{
	LinkMesh(NewMesh, bKeepAnimState);
	LinkAnims();
}

simulated function LinkAnims()
{
	LinkSkelAnim(GetDefaultAnim(SkeletalMesh(Mesh)));
	LinkSkelAnim(DrivingAnims);
}

simulated function Destroyed()
{
	Super.Destroyed();
}

defaultproperties
{
     DrivingAnims=MeshAnimation'ProjectMaricaCore.anim_PMDriving'
     bOwnerNoSee=True
     bReplicateInstigator=True
     RemoteRole=ROLE_SimulatedProxy
     DrawType=DT_Mesh
     AmbientGlow=32
     bGameRelevant=True
     CollisionRadius=0.000000
     CollisionHeight=0.000000
     bBlockZeroExtentTraces=False
     bBlockNonZeroExtentTraces=False
     RotationRate=(Pitch=7800,Yaw=7800,Roll=7800)
     bDirectional=True
}
