//=============================================================================
// DriverBase.
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2011.
//=============================================================================

class DriverBase extends Actor
	notplaceable;

var NKVehicle myVehicle;
var vector LocatedPos;
var bool bFixed;
var bool bHardAttach;

replication
{
	unreliable if (Role == ROLE_Authority)
		myVehicle , bFixed , bHardAttach;
}

simulated function Tick(float DeltaTime)
{
	local vector myLoc;
	local rotator myRot;

	if( myVehicle == None )
		return;

	if( !bHardAttach )
	{
		myLoc = myVehicle.Location + (LocatedPos >> myVehicle.Rotation);
		SetLocation(myLoc);
		if( bFixed )
		{
			myRot.Yaw = myVehicle.Rotation.Yaw;
			SetRotation(myRot);
		}
	}
}

simulated function SetFixedPosition(bool bFix)
{
	bHardAttach = false;
	bFixed = bFix;
}

simulated function SetHardAttach(bool bAttach)
{
	local vector myLoc;

	bHardAttach = bAttach;

	myLoc = myVehicle.Location + (LocatedPos >> myVehicle.Rotation);

	SetLocation(myLoc);

	if( bHardAttach )
		SetBase(myVehicle);
}

defaultproperties
{
	 SoundRadius=200.0
	 SoundPitch=64.0
	 SoundVolume=200.0
	 TransientSoundRadius=0.0
	 TransientSoundVolume=1.0
     bHidden=True
     bReplicateInstigator=True
     AmbientGlow=32
     bGameRelevant=True
     CollisionRadius=0.000000
     CollisionHeight=0.000000
     bBlockZeroExtentTraces=False
     bBlockNonZeroExtentTraces=False
	 bCollideActors=false
	 bCollideWorld=false
     bDirectional=True
}
