//=============================================================================
// MaricaLevelTravelObject.uc
// Author: Nick Pilshikov "Evil"
// For Project Marica
// Revival Games Studios.
// 2014.
//=============================================================================

class MaricaLevelTravelObject extends Inventory;

const NO_AUTO_SAVE_WAIT = 0.1;

var NKVehicle myVehicle;

var travel class<NKVehicle> TravelCarClass;
var travel Material TravelCarSkin;
var travel float TravelCarHealth;
var travel float TravelWheelHealth[4];
var travel int DriverViewPitch;
var travel int TravelCarSongNum;

function PostTravelVehicleLoad()
{
	local NKVehicle tempVehicle;
	local rotator DriverViewRotation;

	if( myVehicle != None )
		return;

	if( Owner != None && TravelCarClass != None )
	{
		Owner.SetCollision(false,false,false);
		tempVehicle = spawn(TravelCarClass,self,,Owner.Location,Owner.Rotation);
		tempVehicle.bRandomSkin = false;

		if( TravelCarSkin != None )
		{
			tempVehicle.CurrentSkin = TravelCarSkin;
			tempVehicle.Skins[tempVehicle.SkinIndex] = TravelCarSkin;
		}

		DriverViewRotation = Pawn(Owner).Controller.Rotation;
		DriverViewRotation.Pitch = DriverViewPitch;
		tempVehicle.Health = TravelCarHealth;
		tempVehicle.RadioSongNumber = TravelCarSongNum;
		TravelCarClass = None;
		TravelCarSkin = None;
		tempVehicle.DriverEnterTravel(Pawn(Owner), DriverViewRotation);
		tempVehicle.bDriverGodMode = false;
		tempVehicle.bImmortal = false;
		tempVehicle.VehiclePostTravel();
	}
}

function Timer()
{
	PostTravelVehicleLoad();
}

function PostBeginPlay()
{
	Super.PostBeginPlay();

	if( Level.Game != None && P2GameInfoSingle(Level.Game) != None )
	{
		if( !P2GameInfoSingle(Level.Game).bUseAutoSave )
			SetTimer(NO_AUTO_SAVE_WAIT, false);
	}
}

event PostSaveGame()
{
	Super.PostSaveGame();

	if( Level.Game != None && P2GameInfoSingle(Level.Game) != None )
	{
		if( P2GameInfoSingle(Level.Game).bUseAutoSave )
			PostTravelVehicleLoad();
	}
}

defaultproperties
{
	 bStasis=false
}
