//=============================================================================
// NKVCar. (Nicks karma based vehicle car class)
//
// Base model: model by EpicGames.
//
// Official page of mod:
// http://www.set-games.ru/index/ProjectMarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2011.
//=============================================================================

class NKVCar extends NKVehicle
	placeable;

defaultproperties
{
	 Tag="Bulldog"
	 ShadowZ=50.0
	 TorqueCurve=(Points=((InVal=0.0,OutVal=100.0),(InVal=550000.0,OutVal=200.0),(InVal=800000.0))

	 SlipVolume=12.0
	 VehicleMaxSpeed=330300.000000
	 WheelRadius=47.0
	 CameraDist=14.0
	 bFixedFPCamera=True
     ExitPos=(Y=-150.000000,Z=15.000000)
     ExitPosPassenger=(Y=150.000000,Z=15.000000)
     DriverPos=(X=-28.000000,Y=-36.000000,Z=45.000000)
     PassengerPos=(X=-28.000000,Y=36.000000,Z=45.000000)
     FPDriverViewPos=(X=120.000000,Y=0.000000,Z=120.000000)
	 FPPassengerViewPos=(X=120.000000,Y=0.000000,Z=120.000000)
     EnterPos=(Y=145.000000,Z=-5.000000)
     ChassisMass=5.000000
     bSpawnBrokenDetail=True
     bAllowBrokenWheels=True
     bDamagableWheels=True
     bSparkWheels=True
     BrokenSkins(0)=Shader'ProjectMaricaCore.BulldogBroken'
     EnginePitch=35.000000
     Description="Base car class. || Model by EpicGames."
     FrontLightClass=Class'ProjectMaricaCore.NVFrontCarLight'
     RearLightClass=Class'ProjectMaricaCore.NVRearCarLight'
     ProjectedLightRot=(Pitch=-1800)
     RadiatorPos=(X=125.000000,Z=65.000000)
     ProjLightPos=(X=220.000000,Z=20.000000)
	 ProjectedLightRot=(Pitch=-100.0)
     bAllowRadio=True
	 ImpactSoundsMin(0)=Sound'ProjectMaricaCore.ut_impact_03'
	 ImpactSoundsMed(0)=Sound'ProjectMaricaCore.ut_impact_01'
	 ImpactSoundsMed(1)=Sound'ProjectMaricaCore.ut_impact_02'
	 ImpactSoundsMax(0)=Sound'ProjectMaricaCore.ut_impact_04'
	 ImpactSoundsMax(1)=Sound'ProjectMaricaCore.ut_impact_05'
	 ImpactSoundsMax(2)=Sound'ProjectMaricaCore.ut_impact_06'
	 ImpactSoundsMax(3)=Sound'ProjectMaricaCore.ut_impact_07'
     RestAngularDamp=0.700000
     EngineSound=Sound'ProjectMaricaCore.UnWheel_idle13'
     MaxSteerAngle=3500.000000
     MaxSpeedAccel=16.000000
     //SteerSpeed=31500.000000
	 SteerSpeed=50000
     bCarIsRTWD=True
     bCarIsFTWD=True
     bAllowChangeView=True
     UnloadWheelHeight=0.013200
     WheelsHealth=60.000000
     WheelsMaxHealth=100.000000
     TireLateralFriction=2.000000
     TireRollSlip=0.060000
     TireLateralSlip=0.040000
     TireSlipRate=0.007000
     TireAdhesion=5.000000
     EngTireClass=Class'ProjectMaricaCore.NKVCarTire'
     SteerTireClass=Class'ProjectMaricaCore.NKVCarTire'
     WheelSteerAlong=100.000000
     WheelSteerAcross=110.000000
     WheelEngAlong=-112.000000
     WheelEngAcross=110.000000
     WheelVert=-10.000000
     WheelFrontRight="RightFrontTIRE"
     WheelFrontLeft="LeftFrontTIRE"
     WheelRearRight="RightRearTIRE"
     WheelRearLeft="LeftRearTIRE"
     bUpdateSusp=True
     SuspStiffness=180.000000
     SuspDamping=5.000000
     RSuspHighLimit=20.000000
     RSuspLowLimit=-20.000000
     VehicleFireClass=Class'ProjectMaricaCore.VehicleFireEmitter'
     ExhaustClass=Class'ProjectMaricaCore.CarExhaust'
     IntCollisionModel=StaticMesh'ProjectMaricaCore.BulldogIntColl'
     DecoSystem=DS_Bones
     ShadowMaxTraceDistance=300.000000
     ImpactSounds(0)=Sound'ProjectMaricaCore.ut_impact_01'
     ImpactSounds(1)=Sound'ProjectMaricaCore.ut_impact_01'
     Mesh=SkeletalMesh'ProjectMaricaCore.BulldogModel'
     StaticMesh=StaticMesh'ProjectMaricaCore.BulldogKColl'
     Skins(0)=Texture'ProjectMaricaCore.BulldogMetalSkin'
     Begin Object Class=KarmaParamsRBFull Name=NKVCarPhysics
         KInertiaTensor(0)=5.000000
         KInertiaTensor(3)=25.000000
         KInertiaTensor(5)=45.000000
         //KInertiaTensor(0)=20.000000
         //KInertiaTensor(3)=30.000000
         //KInertiaTensor(5)=58.000000
         KCOMOffset=(X=-0.300000,Z=-0.500000)
         KLinearDamping=0.050000
         KAngularDamping=0.700000
         KStartEnabled=True
         bKNonSphericalInertia=True
         KFriction=0.200000
         Name="NKVCarPhysics"
     End Object
     KParams=KarmaParamsRBFull'NKVCarPhysics'
}
