//=============================================================================
// NKVehicleTrigger. (Special trigger for vehicles)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2010 - 2011.
//=============================================================================

class NKVehicleTrigger extends ScriptedSequence
	notplaceable;

var NKVehicle myVehicle;
var bool bExitTrigger;
var Pawn myUser, IgnorePawn;
var float ReTriggerDelay;
var	float TriggerTime;

function SetPawnIgnore(Pawn Ignored, float IgnoredTime)
{
	IgnorePawn = Ignored;
	SetTimer(IgnoredTime,false);
	//log(IgnorePawn$" now is ignored by trigger");
}

function Touch( Actor Other )
{
	local Pawn User;

	if( Instigator == None )
		Instigator = None;

	if(Other == None
		|| myVehicle == None
		|| myVehicle.bAIControlled
		|| Other.Instigator == None
		|| Pawn(Other) == IgnorePawn
		|| Other.IsA('MpMonkey')
		|| Other.IsA('MpHeadcrab')
		|| Other.IsA('NPVehicle')
		|| Other.IsA('HelicopterVehicle')
		|| Other.IsA('KVehicle')
		|| Other.IsA('PostalMultiplayerChicken')
		|| Other.IsA('PostalMultiplayerAirCraftVehicle'))
			return;

	User = Pawn(Other);

	if(User == None)
		return;

	if(ReTriggerDelay > 0)
	{
		if ( Level.TimeSeconds - TriggerTime < ReTriggerDelay )
			return;
		TriggerTime = Level.TimeSeconds;
	}

	if(!bExitTrigger && User.Physics != PHYS_None 
		&& (myVehicle.Driver == None || (myVehicle.Passenger == None && myVehicle.bAllowPassenger))
		&& !myVehicle.bLocked)
		User.ReceiveLocalizedMessage(class'NVMessage', 0);
	else if(myVehicle.bLocked)
		User.ReceiveLocalizedMessage(class'NVMessage', 5);
}

function UsedBy( Pawn user )
{
	if(User == None 
		|| User == IgnorePawn 
		|| myVehicle.bAIControlled
		|| User.IsA('MpMonkey')
		|| User.IsA('MpHeadcrab')
		|| User.IsA('NPVehicle')
		|| User.IsA('HelicopterVehicle')
		|| User.IsA('KVehicle')
		|| User.IsA('PostalMultiplayerChicken')
		|| User.IsA('PostalMultiplayerAirCraftVehicle'))
		return;

	if(User != myVehicle.Driver
		&& User != myVehicle.Passenger
		&& !bExitTrigger)
		NKVehicle(Owner).TryToDrive(User);
	else
		NKVehicle(Owner).TryToExit(myUser);
}

function Timer()
{
	IgnorePawn = None;
}

defaultproperties
{
	 bAlwaysTick=true
	 bCollideActors=False
     ReTriggerDelay=2.000000
     RemoteRole=ROLE_None
     bCollideWhenPlacing=False
     CollisionRadius=20.000000
     CollisionHeight=20.000000
}
