//=============================================================================
// NPVehicleFactory. (Nicks pawn based vehicle factory class)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2010 - 2011.
//=============================================================================

class NPVehicleFactory extends Vehicles
	notplaceable;

var(SpawnConfig) class<NPVehicle> VehicleClass;
var NPVehicle SpawnedVehicle;
var int VehicleCount;
var(SpawnConfig) class<DamageType> RanOverDamage;
var(SpawnConfig) float RespawnTime;
var(SpawnConfig) bool bSpecialVehicle;

event Tick(float DeltaTime)
{
	if(VehicleCount == 1)
		return;

	SpawnVehicleNow();
}

function VehicleDestroyed()
{
	SetTimer(RespawnTime, false);
}

function Timer()
{
	VehicleCount--;
}

simulated function SpawnVehicleNow()
{
	local Actor CollideActor;

	if(VehicleClass == None)
		return;

	foreach CollidingActors(class'Actor', CollideActor, CollisionRadius, Location)
	{
		if(CollideActor != None)
		{
			if((CollideActor.bBlockPlayers
				|| CollideActor.bBlockActors
				|| (CollideActor.bBlockKarma && !CollideActor.IsA('IntCollisionActor'))) && (!CollideActor.bStatic && !CollideActor.bCollideWorld))
			return;
		}
	}

	SpawnedVehicle = spawn(VehicleClass, , , Location, Rotation);

	if( SpawnedVehicle == None )
		return;

	SpawnedVehicle.RanOverDamage = RanOverDamage;
	SpawnedVehicle.bSpecialVehicle = bSpecialVehicle;
	VehicleCount++;
	SpawnedVehicle.OurFactory = self;
}

defaultproperties
{
	 RespawnTime=40.0
     RanOverDamage=Class'NVDamage'
     DrawType=DT_Mesh
}
