//=============================================================================
// NPVehicleTrigger.
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2011.
//=============================================================================

class NPVehicleTrigger extends ScriptedSequence
	notplaceable;

var NPVehicle myVehicle;
var float ReTriggerDelay;
var	float TriggerTime;
var bool bExitTrigger;
var Pawn IgnorePawn;

function SetPawnIgnore(Pawn Ignored, float IgnoredTime)
{
	IgnorePawn = Ignored;
	SetTimer(IgnoredTime,false);
	//log(IgnorePawn$" now is ignored by trigger");
}

function Touch(Actor Other)
{
	local Pawn User;

	if(Other == None
		|| myVehicle == None
		|| Other.IsA('MpMonkey')
		|| Other.IsA('MpHeadcrab')
		|| Other.IsA('NPVehicle')
		|| Other.IsA('HelicopterVehicle')
		|| Other.IsA('KVehicle')
		|| Other.IsA('PostalMultiplayerChicken')
		|| Other.IsA('PostalMultiplayerAirCraftVehicle'))
		return;

	User = Pawn(Other);

	if( User == None
		|| User.Health <= 0 )
		return;

	if(ReTriggerDelay > 0)
	{
		if ( Level.TimeSeconds - TriggerTime < ReTriggerDelay )
			return;
		TriggerTime = Level.TimeSeconds;
	}

	if(!User.IsA('NPVehicle') && !bExitTrigger)
		User.ReceiveLocalizedMessage(class'NVMessage', 0);
}

function UsedBy(Pawn User)
{
	local Controller C;

	if( User == None 
		|| User.IsA('MpMonkey')
		|| User.IsA('MpHeadcrab')
		|| (User.IsA('NPVehicle') && User != NPVehicle(Owner))
		|| (User.IsA('HelicopterVehicle') && User != NPVehicle(Owner))
		|| User.IsA('KVehicle')
		|| User.IsA('PostalMultiplayerChicken')
		|| User.IsA('PostalMultiplayerAirCraftVehicle') )
	return;

	if( User != None )
		C = User.Controller;

	if( C == None 
		|| User.Health <= 0 )
		return;


	if(!C.IsInState('PlayerHelicoptering')
		&& !C.IsInState('PlayerSpidering')
		&& !C.IsInState('PlayerDriving')
		&& !bExitTrigger 
		&& User != myVehicle
		&& User != IgnorePawn)
		NPVehicle(Owner).TryToDrive(User);
	else NPVehicle(Owner).DriverLeave();
}

function Timer()
{
	IgnorePawn = None;
}

function Tick(float DeltaTime)
{
	if(myVehicle != None && bExitTrigger)
		SetLocation(myVehicle.Location);
}

defaultproperties
{
     ReTriggerDelay=1.000000
     RemoteRole=ROLE_None
     bCollideWhenPlacing=False
     CollisionRadius=40.000000
     CollisionHeight=40.000000
}
