//=============================================================================
// NVLightProjector. (Nicks vehicle light dynamic projector)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// 2011.
//=============================================================================

class NVLightProjector extends Projector;

var Actor BaseActor;
var float ActorSpeed;

replication
{
	unreliable if (Role == ROLE_Authority)
		BaseActor, ActorSpeed;
}

function UpdateProjection()
{
	DetachProjector(true);
	SetCollision(false,false,false);
	AttachProjector();
	SetCollision(true,false,false);
}

function Tick(float DeltaTime)
{
    if (Role == ROLE_Authority)
		if(BaseActor != None)
			ActorSpeed = VSize(BaseActor.Velocity);
	if(ActorSpeed > 1.0)
		UpdateProjection();
}

simulated event Touch( Actor Other );
simulated event Untouch( Actor Other );

defaultproperties
{
	 
     MaterialBlendingOp=PB_Modulate
     FrameBufferBlendingOp=PB_Add
     FOV=60
     MaxTraceDistance=2300
     bProjectOnUnlit=True
     bGradient=True
     bProjectOnAlpha=True
     bStatic=False
     DrawScale=0.500000
}
