//=============================================================================
// NVMessage. (Base class of messages for vehicles)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2010.
//=============================================================================
class NVMessage extends LocalMessage
	config(NicksVehicles);

var localized string GetInMessage;
var localized string GetOutMessage;
var localized string FAQHowToDrive;
var localized string FAQHowToChangeView;
var localized string FAQHowToChangeSongs;
var localized string FAQHowToShoot;
var localized string FAQHowToShoot1;
var localized string FAQHowToShoot2;
var localized string OpenDoorMessage;
var localized string VehicleIsLocked;

///FIX2015
var byte ActionUseGameSwitch;
var byte ActionUseGame;//0~steam, 1~MP, 2~orig
var config string ActionKeyString;
var localized string ChangeKeyMessage;
var localized string ChangeKeyMessageOrig;
var localized string ActionMessageMP;
var localized string SongsMessageMP;
///FIX2015

static function string GetConfigActionKey()
{
	local int AscKey;
	if( default.ActionUseGame == 2 )
	{
		AscKey = int(default.ActionKeyString);//Asc(default.ActionKeyString);
		return Chr(AscKey);
	}
	return ("%KEY_"$default.ActionKeyString$"%");
}

static function string GetString(
	PlayerController P,
	optional int Switch,
	optional PlayerReplicationInfo RelatedPRI_1, 
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object OptionalObject
	)
{
	if( default.ActionUseGame == 1 )
	{
		switch(Switch)
		{
		case 0:
			return default.ActionMessageMP;
			break;

		case 4:
			return default.SongsMessageMP;
			break;

		case 5:
			return default.VehicleIsLocked;
			break;

		case 9:
			return default.ActionMessageMP;
			break;
		}
		return "";
	}

	switch(Switch)
	{
	case 0:
		if( int(default.ActionKeyString) == 0 || len(default.ActionKeyString) == 0 )
		{
			if( default.ActionUseGame == 2 )
				return default.ChangeKeyMessageOrig;
			else return default.ChangeKeyMessage;
			break;
		}
		return default.GetInMessage@GetConfigActionKey();
		break;

	case 1:
		if( int(default.ActionKeyString) == 0 || len(default.ActionKeyString) == 0 )
		{
			return "";
			//return default.ChangeKeyMessage;
			break;
		}
		return default.GetOutMessage@GetConfigActionKey();
		break;

	case 2:
		return default.FAQHowToDrive;
		break;

	case 3:
		return default.FAQHowToChangeView;
		break;

	case 4:
		if( default.ActionUseGame == 2 )
		{
			return default.SongsMessageMP;
			break;
		}
		return default.FAQHowToChangeSongs;
		break;

	case 5:
		return default.VehicleIsLocked;
		break;

	case 6:
		if( default.ActionUseGame == 2 )
		{
			return "";
			break;
		}
		return default.FAQHowToShoot;
		break;

	case 7:
		if( default.ActionUseGame == 2 )
		{
			return "";
			break;
		}
		return default.FAQHowToShoot1;
		break;

	case 8:
		if( default.ActionUseGame == 2 )
		{
			return "";
			break;
		}
		return default.FAQHowToShoot2;
		break;

	case 9:
		if( int(default.ActionKeyString) == 0 || len(default.ActionKeyString) == 0 )
		{
			if( default.ActionUseGame == 2 )
				return default.ChangeKeyMessageOrig;
			else return default.ChangeKeyMessage;
			break;
		}
		return default.OpenDoorMessage@GetConfigActionKey();
		break;
	}
}

defaultproperties
{
	 ActionUseGame=0
	 ActionMessageMP="Write USE in console [~]/[Tab], or bind it in User.ini"
	 SongsMessageMP="Press [C] (crouch) to changes songs."
	 ChangeKeyMessage="Take Vehicle Launcher, press %KEY_ThrowWeapon% and change enter key. Or write USE in console %KEY_ConsoleToggle%!"
	 ChangeKeyMessageOrig="Take Vehicle Launcher, press [Z] and change enter key. Or write USE in console [~]/[Tab]!"
     GetInMessage="Enter:"
     GetOutMessage="Exit:"
     FAQHowToDrive="Press %KEY_SPECIAL_MOVEMENT% to drive a car."
     FAQHowToChangeSongs="Press %KEY_DUCK% to change songs."
     FAQHowToShoot="Press %KEY_DUCK% to shoot."
	 FAQHowToShoot1="Press %KEY_Fire% to shoot."
	 FAQHowToShoot2="Press %KEY_Fire%/%KEY_AltFire% to shoot."
	 OpenDoorMessage="Open:"
     VehicleIsLocked="Locked!"
     bIsUnique=True
     bIsConsoleMessage=false
     bFadeMessage=True
}
