//=============================================================================
// TireFXBase.uc
// Author: Nick Pilshikov "Evil"
// For: Postal 2 Project Marica
// Site: Set-Games.ru / Revival-Games.ru
// Revival Games Studios.
// 2014.
//=============================================================================

class TireFXBase extends P2Emitter;

var int NETParticlesPerSecond;
var int NETInitialParticlesPerSecond;
var bool bServerSelfDestroy;
var bool bClientSelfDestroy;

var bool bNETRelativeSizeUpd;
var bool bRelativeSizeUpd;

replication
{
	unreliable if( Role == ROLE_Authority )
		NETParticlesPerSecond , NETInitialParticlesPerSecond , bServerSelfDestroy , bNETRelativeSizeUpd;
}

simulated function xUpdateRelativeSize()
{
	Emitters[0].SizeScale[0].RelativeSize = FMin(Emitters[0].SizeScale[0].RelativeSize*4,1.5);
	Emitters[0].SizeScale[1].RelativeSize = FMin(Emitters[0].SizeScale[1].RelativeSize*3,3.5);
}

simulated function Tick(float DeltaTime)
{
	if( bServerSelfDestroy )
	{
		if( !bClientSelfDestroy )
		{
			ForceKillEmitter();
			bClientSelfDestroy = true;
		}
		return;
	}
	if( Level.NetMode == NM_Client )
	{
		if( Emitters[0].ParticlesPerSecond != NETParticlesPerSecond )
		{
			Emitters[0].ParticlesPerSecond = NETParticlesPerSecond;
			Emitters[0].InitialParticlesPerSecond = NETInitialParticlesPerSecond;
			Emitters[0].AllParticlesDead = false;
		}
		if( bNETRelativeSizeUpd && !bRelativeSizeUpd )
		{
			xUpdateRelativeSize();
			bRelativeSizeUpd = true;
		}
	}
	else
	{
		if( NETParticlesPerSecond != Emitters[0].ParticlesPerSecond )
		{
			NETParticlesPerSecond = Emitters[0].ParticlesPerSecond;
			NETInitialParticlesPerSecond = Emitters[0].InitialParticlesPerSecond;
		}
	}
}

simulated function ForceKillEmitter()
{
	AmbientSound = None;
	SoundVolume = 0;
	Kill();
}

simulated function ForceSelfDestroy()
{
	bServerSelfDestroy = true;
	ForceKillEmitter();
}

defaultproperties
{
	 SoundVolume=0
	 bReplicateMovement=true
	 bNoDelete=false
	RemoteRole=ROLE_SimulatedProxy
}
