//=============================================================================
// UnderWaterExplosion. (Under water explosion for all types of instigator!)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2010.
//=============================================================================

class UnderWaterExplosion extends P2Explosion;

const	FIRE_INDEX	=	0;
const	DIRT_INDEX	=	1;
const	DUST_INDEX	=	2;
const	BLOOD_INDEX	=	3;
var Sound  GrenadeExplodeWater;

replication
{
	unreliable if(Role==ROLE_Authority)
		ClientMakeBlood;
}

function CheckForHitType(Actor Other)
{
	local vector endpt;

	Emitters[DIRT_INDEX].Disabled=true;
	Emitters[DUST_INDEX].Disabled=true;
	
	if(P2Pawn(Other) != None)
	{
		ClientMakeBlood();
	}
}

simulated function ClientMakeBlood()
{
	// Only if we allow blood
	if(class'P2Player'.static.BloodMode())
		Emitters[BLOOD_INDEX].Disabled=false;
}

auto state Exploding
{
Begin:
 	PlaySound(GrenadeExplodeWater,,1.0,,,,true);
	Sleep(DelayToHurtTime);
	CheckHurtRadius(ExplosionDamage, ExplosionRadius, MyDamageType, ExplosionMag, Location);
	NotifyPawns();
}

defaultproperties
{
     GrenadeExplodeWater=Sound'LevelSoundsTrois.Weather.Splash2'
     ExplosionMag=40000.000000
     ExplosionDamage=130.000000
     ExplosionRadius=700.000000
     MyDamageType=Class'UnderWaterExplosionDamage'
     Begin Object Class=SpriteEmitter Name=UnderWaterExplosionEmitterFX01
         Acceleration=(Z=-180.000000)
         UseColorScale=True
         ColorScale(0)=(Color=(B=255,G=250,R=200))
         ColorScale(1)=(RelativeTime=0.800000,Color=(B=255,G=250,R=200))
         ColorScale(2)=(RelativeTime=1.000000)
         RespawnDeadParticles=False
         StartLocationRange=(Z=(Max=15.000000))
         SpinParticles=True
         StartSpinRange=(X=(Max=1.000000))
         UseSizeScale=True
         SizeScale(0)=(RelativeSize=4.200000)
         SizeScale(1)=(RelativeTime=1.000000,RelativeSize=4.500000)
         StartSizeRange=(X=(Min=10.000000,Max=20.000000))
         UniformSize=True
         InitialParticlesPerSecond=50.000000
         AutomaticInitialSpawning=False
         Texture=Texture'ProjectMaricaCore.xSplashBase'
         TextureUSubdivisions=2
         TextureVSubdivisions=2
         BlendBetweenSubdivisions=True
         LifetimeRange=(Min=0.800000,Max=0.800000)
         StartVelocityRange=(Z=(Min=50.000000,Max=95.000000))
         Name="UnderWaterExplosionEmitterFX01"
     End Object
     Emitters(0)=SpriteEmitter'UnderWaterExplosionEmitterFX01'
     Begin Object Class=SpriteEmitter Name=UnderWaterExplosionEmitterFX02
         Acceleration=(Z=-150.000000)
         UseColorScale=True
         ColorScale(0)=(Color=(B=255,G=250,R=200))
         ColorScale(1)=(RelativeTime=1.000000,Color=(B=255,G=250,R=200))
         FadeOutStartTime=0.500000
         FadeOut=True
         MaxParticles=12
         RespawnDeadParticles=False
         SpinParticles=True
         StartSpinRange=(X=(Max=1.000000))
         UseSizeScale=True
         UseRegularSizeScale=False
         SizeScale(0)=(RelativeSize=4.200000)
         SizeScale(1)=(RelativeTime=0.500000,RelativeSize=4.000000)
         SizeScale(2)=(RelativeTime=1.000000,RelativeSize=4.500000)
         StartSizeRange=(X=(Min=20.000000,Max=30.000000))
         UniformSize=True
         InitialParticlesPerSecond=500.000000
         AutomaticInitialSpawning=False
         Texture=Texture'ProjectMaricaCore.xWaterDrops2'
         TextureUSubdivisions=1
         TextureVSubdivisions=2
         BlendBetweenSubdivisions=True
         LifetimeRange=(Min=1.200000,Max=1.200000)
         StartVelocityRange=(X=(Min=-32.000000,Max=32.000000),Y=(Min=-32.000000,Max=32.000000),Z=(Min=80.000000,Max=160.000000))
         Name="UnderWaterExplosionEmitterFX02"
     End Object
     Emitters(1)=SpriteEmitter'UnderWaterExplosionEmitterFX02'
     AutoDestroy=True
     bHighDetail=True
     TransientSoundRadius=600.000000
}
