//=============================================================================
// WaterVolume. (Water volume for level designers.
//					Special swimming physics volume)
//
// Official page of mod:
// http://www.set-games.ru/index/projectmarica/0-8
//
// Author: Evil T-ModZ (Nick)
// Email: Nick_Pv@mail.ru / TModZ.Evil@Yahoo.com
// Site: Set-Games.ru
// T-ModZ. All Rights Reserved.
// 2011.
//=============================================================================

class WaterVolume extends PhysicsVolume;

var ExtinguishSteamEmitter ESEmitter;
var() Class<actor> BigSpashActor;
var() sound BigSpashSound;

simulated event ActorEnteredVolume(Actor Other) 
{
	local FPSPawn EPawn;
	local P2MoCapPawn MCPawn;
	local AnimalPawn APawn;
	local NKVehicle Car;
	local UnderWaterExplosion EvilsSplash;
	local int i;

	if(Other.IsA('GasPuddle'))
		Other.Destroy();
	if(Other.IsA('GasPourFeeder'))
		Other.Destroy();
	if(Other.IsA('DirtClodsMachineGun'))
		Other.Destroy();
	if(Other.IsA('PickupHitPuff'))
		Other.Destroy();
	if(Other.IsA('SmokeHitPuffMelee'))
		Other.Destroy();
	if(Other.IsA('SmokeHitPuffRifle'))
		Other.Destroy();
	if(Other.IsA('SmokeHitPuffMachineGun'))
		Other.Destroy();
	if(Other.IsA('SmokeHitPuffShotGun'))
		Other.Destroy();
	if(Other.IsA('SmokeHitPuffGeneric'))
		Other.Destroy();
	if(Other.IsA('RocketSmokePuff'))
		Other.Destroy();
	if(Other.IsA('SparkHitMachineGun') || Other.IsA('SparkHitProjectile'))
		Other.Destroy();
	if(Other.IsA('NapalmStarterFollow'))
	{
		ESEmitter = spawn(class'ExtinguishSteamEmitter', , , Other.Location);
		ESEmitter.Instigator = other.Instigator;
		Other.Destroy();
	}
	if(Other.IsA('NapalmTrail'))
		Other.Destroy();
	if(Other.IsA('FireNapalmStreak'))
		Other.Destroy();
	if(Other.IsA('NapalmPourFeeder'))
		Other.Destroy();
	if(Other.IsA('VehicleFireEmitter'))
	{
		ESEmitter = spawn(class'ExtinguishSteamEmitter', , , Other.Location);
		ESEmitter.Instigator = other.Instigator;
		Other.Destroy();
	}
	if(Other.IsA('WheelFireEmitter'))
	{
		ESEmitter = spawn(class'ExtinguishSteamEmitter', , , Other.Location);
		ESEmitter.Instigator = other.Instigator;
		Other.Destroy();
	}
	if(Other.IsA('VehicleSmokeEmitter'))
		Other.Destroy();
	if(Other.IsA('VehicleEngineFireEmitter'))
	{
		ESEmitter = spawn(class'ExtinguishSteamEmitter', , , Other.Location);
		ESEmitter.Instigator = other.Instigator;
		Other.Destroy();
	}
	if(Other.IsA('NapalmProjectile'))
	{
		if(NapalmProjectile(Other).FuelLeak != None)
		{
			NapalmProjectile(Other).FuelLeak.SelfDestroy();
		}
	}
	if(Other.IsA('MolotovWickFire'))
		Other.Destroy();
	if(Other.IsA('RocketExplosion'))
	{
		EvilsSplash = spawn(class'UnderWaterExplosion', , , Other.Location);
		EvilsSplash.Instigator = other.Instigator;
		Other.Destroy();
	}
	if(Other.IsA('tExploBall'))
	{
		EvilsSplash = spawn(class'UnderWaterExplosion', , , Other.Location);
		EvilsSplash.Instigator = other.Instigator;
		Other.Destroy();
	}
	if(Other.IsA('tExploPillar'))
	{
		EvilsSplash = spawn(class'UnderWaterExplosion', , , Other.Location);
		EvilsSplash.Instigator = other.Instigator;
		Other.Destroy();
	}
	if(Other.IsA('tVehicleExplosion'))
	{
		EvilsSplash = spawn(class'UnderWaterExplosion', , , Other.Location);
		EvilsSplash.Instigator = other.Instigator;
		Other.Destroy();
	}
	if(Other.IsA('GrenadeExplosion'))
	{
		EvilsSplash = spawn(class'UnderWaterExplosion', , , Other.Location);
		EvilsSplash.Instigator = other.Instigator;
		Other.Destroy();
	}
	if(Other.IsA('PlagueExplosion'))
	{
		EvilsSplash = spawn(class'UnderWaterExplosion', , , Other.Location);
		EvilsSplash.Instigator = other.Instigator;
		Other.Destroy();
	}
	if(Other.IsA('NapalmExplosion'))
	{
		EvilsSplash = spawn(class'UnderWaterExplosion', , , Other.Location);
		EvilsSplash.Instigator = other.Instigator;
		Other.Destroy();
	}
	if(Other.IsA('MolotovExplosion'))
	{
		EvilsSplash = spawn(class'UnderWaterExplosion', , , Other.Location);
		EvilsSplash.Instigator = other.Instigator;
		Other.Destroy();
	}
	MCPawn = P2MoCapPawn(Other);
	if(MCPawn != None && MCPawn.MyHead != None && MCPawn.MyHead.MyPartFire != None) 
	{
		ESEmitter = spawn(class'ExtinguishSteamEmitter', , , Other.Location);
		ESEmitter.Instigator = other.Instigator;
		MCPawn.MyHead.MyPartFire.destroy();
	}

	EPawn = FPSPawn(Other);
	if(EPawn != None && EPawn.MyBodyFire != None)
	{
		ESEmitter = spawn(class'ExtinguishSteamEmitter', , , Other.Location);
		ESEmitter.Instigator = other.Instigator;
		EPawn.MyBodyFire.Destroy();
	}

	if(Other.IsA('FireEmitter'))
	{
		ESEmitter = spawn(class'ExtinguishSteamEmitter', , , Other.Location);
		ESEmitter.Instigator = other.Instigator;
		Other.Destroy();
	}

	APawn = AnimalPawn(Other);
	if(APawn != None && APawn.MyBodyFire != None)
	{
		ESEmitter = spawn(class'ExtinguishSteamEmitter', , , Other.Location);
		ESEmitter.Instigator = other.Instigator;
		APawn.MyBodyFire.Destroy();
	}
}

simulated event ActorLeavingVolume(Actor Other)
{
	Super.ActorLeavingVolume(Other);
	if(Other.IsA('NapalmProjectile'))
	{
		if(NapalmProjectile(Other).FuelLeak != None)
			NapalmProjectile(Other).FuelLeak.SelfDestroy();
		NapalmProjectile(Other).FuelLeak = spawn(class'FX.NapalmPourFeeder', Other.Owner, , Other.Location, Other.Rotation);
		if(NapalmProjectile(Other).FuelLeak != None)
		{
			NapalmProjectile(Other).FuelLeak.MyOwner = Other.Instigator;
			NapalmProjectile(Other).FuelLeak.SetBase(Other);
		}
	}
}

event touch(Actor Other)
{
	Super(Volume).Touch(Other);
	if( bNoInventory && Other.IsA('Inventory') && (Other.Owner == None) )
	{
		Other.LifeSpan = 1.5;
		return;
	}
	if( bMoveProjectiles && (ZoneVelocity != vect(0,0,0)) )
	{
		if ( Other.Physics == PHYS_Projectile )
			Other.Velocity += ZoneVelocity;
		else if ( Other.IsA('Effects') && (Other.Physics == PHYS_None) )
		{
			Other.SetPhysics(PHYS_Projectile);
			Other.Velocity += ZoneVelocity;
		}
	}
	if( bPainCausing )
	{
		if ( Other.bDestroyInPainVolume )
		{
			Other.Destroy();
			return;
		}
		CausePainTo(Other);
	}
	if(Other.CanSplash())
		PlayEntrySplash(Other);
}

simulated function PlayEntrySplash(Actor Other)
{
	local vector StartLoc, Vel2D;

	if( (EntryActor != None) && (Level.NetMode != NM_DedicatedServer) )
	{
		StartLoc = Other.Location - Other.CollisionHeight*vect(0,0,0.8);
		if ( Other.CollisionRadius > 0 )
		{
			Vel2D = Other.Velocity;
			Vel2D.Z = 0;
			if ( VSize(Vel2D) > 100 )
				StartLoc = StartLoc + Normal(Vel2D) * CollisionRadius;
		}
		if(Other.Mass > 400)
		{
			if( BigSpashSound != None )
			{
				Other.PlaySound(BigSpashSound, SLOT_Interact, Other.TransientSoundVolume);
				if ( Other.Instigator != None )
					MakeNoise(1);
			}
			Spawn(BigSpashActor,,,StartLoc,rot(16384,0,0));
		}
		else
		{
			if( EntrySound != None )
			{
				Other.PlaySound(EntrySound, SLOT_Interact, Other.TransientSoundVolume);
				if ( Other.Instigator != None )
					MakeNoise(1);
			}
			Spawn(EntryActor,,,StartLoc,rot(16384,0,0));
		}
	}
}

simulated event untouch(Actor Other)
{
	if(Other.CanSplash())
		PlayExitSplash(Other);
}

simulated function PlayExitSplash(Actor Other)
{
	if(Other.Mass > 400)
	{
		if( BigSpashSound != None ) // SLOT_Interact SLOT_Misc
			Other.PlaySound(BigSpashSound, SLOT_Interact, Other.TransientSoundVolume);
		if( (ExitActor != None) && (Level.NetMode != NM_DedicatedServer) )
			Spawn(BigSpashActor,,,Other.Location - Other.CollisionHeight*vect(0,0,0.8),rot(16384,0,0));
	}
	else
	{
		if( ExitSound != None ) // SLOT_Interact SLOT_Misc
			Other.PlaySound(ExitSound, SLOT_Interact, Other.TransientSoundVolume);
		if( (ExitActor != None) && (Level.NetMode != NM_DedicatedServer) )
			Spawn(ExitActor,,,Other.Location - Other.CollisionHeight*vect(0,0,0.8),rot(16384,0,0));
	}
}

defaultproperties
{
     BigSpashActor=Class'BigWaterSplash'
     BigSpashSound=Sound'LevelSoundsTrois.Weather.Splash2'
     Gravity=(Z=-950.000000)
     EntrySound=Sound'LevelSoundsTrois.Weather.Splash2'
     ExitSound=Sound'LevelSoundsTrois.Weather.Splash1'
     EntryActor=Class'WaterSplash'
     ExitActor=Class'WaterRing'
     FluidFriction=2.400000
     bWaterVolume=True
     bDistanceFog=True
     DistanceFogColor=(B=128,G=64,R=32,A=64)
     DistanceFogStart=8.000000
     DistanceFogEnd=1500.000000
     LocationName="under water"
     bBlockZeroExtentTraces=True
}
